package com.zeal.gov.kar.pwmt.daos;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.w3c.dom.ls.LSResourceResolver;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;

import com.zeal.gov.kar.pwmt.common.utils.AppUserDetails;
import com.zeal.gov.kar.pwmt.models.AutoSync;
import com.zeal.gov.kar.pwmt.models.Isssuetype;
import com.zeal.gov.kar.pwmt.models.Login_Info;
import com.zeal.gov.kar.pwmt.models.TablesWc;
import com.zeal.gov.kar.pwmt.models.WorkCoordinatePhotos;
import com.zeal.gov.kar.pwmt.models.Work_Chainage;
import com.zeal.gov.kar.pwmt.models.Work_Component_UpdateStatus;
import com.zeal.gov.kar.pwmt.models.Work_Component_Updations_Photo;
import com.zeal.gov.kar.pwmt.models.Work_Components;
import com.zeal.gov.kar.pwmt.models.Work_Coordinates;
import com.zeal.gov.kar.pwmt.models.Work_Main;
import com.zeal.gov.kar.pwmt.models.workissues;

public class BaseService {
	@SuppressWarnings("unused")
	private BaseDao baseDao;
	@SuppressWarnings("unused")
	private Context context;
	ContentValues contentValues;

	public BaseService(Context context) {
		baseDao = new BaseDao(context);
		this.context = context;
	}
	public List<Isssuetype> getissueDescription(){
		List<Isssuetype> lstdesc = null;
		Cursor cursor = null;

		try{
			lstdesc = new ArrayList<Isssuetype>();
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_MASTER_ISSUETYPE);
			int count = cursor.getCount();
			if(count>0){

				while(!cursor.isAfterLast()){
					Isssuetype isssue = new  Isssuetype();
					isssue.setIssueDescription(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_MASTER_ISSUETYPE_DESCRIPTION)));
					lstdesc.add(isssue);
					cursor.moveToNext();
				}
			}
		}
		catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor!= null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return lstdesc;
	}

	public int getissueid(String desc){
		int id = 0;
		String[] args = {desc};
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_MASTER_ISSUETYPE,DBConstants.COLUMN_MASTER_ISSUETYPE_DESCRIPTION + " =?",args);
			int count = cursor.getCount();
			if(count > 0){
				id = cursor.getInt(cursor.getColumnIndex((DBConstants.COLUMN_MASTER_ISSUETYPE_ISSUEID)));
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return id;
	}
	public boolean uservalidation(String username,String password)
	{
		String[] args = {username,password};
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_LOGIN_INFO, DBConstants.COLUMN_LOGIN_INFO_LOGINID +"=? and "+DBConstants.COLUMN_LOGIN_INFO_PASSWORD + "=? ", args);
			if(cursor!=null){
				if(cursor.getCount()>0){
					return true;
				}


			}
		}catch(Exception e){
			e.printStackTrace();
		}
		finally
		{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return false;
	}

	public boolean insertintoworkissues(workissues issues){
		ContentValues values = new ContentValues();
		long cursor;
		values.put(DBConstants.COLUMN_WORK_ISSUES_ISSUEID, issues.getIssueId());
		values.put(DBConstants.COLUMN_WORK_ISSUES_ISSUETYPEID, issues.getIssueTypeId());
		values.put(DBConstants.COLUMN_WORK_ISSUES_ISSUEDESCRIPTION, issues.getIssueDescription());
		values.put(DBConstants.COLUMN_WORK_ISSUES_WORKID, issues.getWorkId());
		values.put(DBConstants.COLUMN_WORK_ISSUES_ISSUERAISEDBY, issues.getIssueRaisedby());
		values.put(DBConstants.COLUMN_WORK_ISSUES_ISSUERAISEDON, issues.getIssueRaisedon());
		values.put(DBConstants.COLUMN_WORK_ISSUES_UPDATEID, issues.getUpdationId());
		values.put(DBConstants.COLUMN_WORK_ISSUES_XMLID, "NULL");
		try{
			baseDao.open();
			cursor = baseDao.Insert(DBConstants.TABLE_WORK_ISSUES, values);
		}
		catch (SQLException e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			baseDao.close();
		}
		return  true;
	}


	public HashMap<String, Object> getWorksForChainageSpinner(String workId, String componentId,
			String groupComponentId) {
		// TODO Auto-generated method stub
		HashMap<String, Object> hmChainage = new HashMap<String, Object>();
		HashMap<String, Integer> hmChainageSpinner = new HashMap<String, Integer>();
		List<String> lstChainageNames = new ArrayList<String>();
		Cursor cursor = null;
		try{
			String[] selArgs = {workId,componentId,groupComponentId};
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_CHAINAGE, DBConstants.COLUMN_WORK_CHAINAGE_WORKID +"=? and "+DBConstants.COLUMN_WORK_CHAINAGE_COMPONENTGROUPID+"=? and "+DBConstants.COLUMN_WORK_CHAINAGE_GROUPCOMPONENTID+"=?", selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						lstChainageNames.add(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_CHAINAGE_CHAINAGENAME)));
						hmChainageSpinner.put(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_CHAINAGE_CHAINAGENAME)), cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_CHAINAGE_WORKCHAINAGEID)));
						cursor.moveToNext();
					}
				}
			}

		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		hmChainage.put("List", lstChainageNames);
		hmChainage.put("Hashmap", hmChainageSpinner);

		return hmChainage;
	}

	public List<Work_Components> getWorkComponentsForSelectedChainage(
			String workId, String componentId, String groupComponentId,
			String chainageId) {
		// TODO Auto-generated method stub
		Work_Components wc;
		List<Work_Components> lstWorkComponents = new ArrayList<Work_Components>();
		String[] selArgs = {workId,componentId,groupComponentId,chainageId};
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COMPONENTS, DBConstants.COLUMN_WORK__COMPONENTS_WORKID +"=? and "+DBConstants.COLUMN_WORK__COMPONENTS_COMPONENTGROUPID+"=? and "+DBConstants.COLUMN_WORK__COMPONENTS_GROUPCOMPONENTID+"=? and "+DBConstants.COLUMN_WORK__COMPONENTS_WORKCAHAINAGEID+"=?", selArgs);
			//			cursor = baseDao.RawQuery("SELECT * FROM Work_Components WHERE WorkId="+workId+" and ComponentGroupId="+componentId+" and GroupComponentId="+groupComponentId+" and WorkChainageId="+chainageId+"", null);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						wc = new Work_Components();
						//[WorkComponentId, WorkId, WorkChainageId, ComponentGroupId, GroupComponentName, GroupComponentId, ComponentId, SubComponentId, LocationKM, FromDate, ToDate, CreatedBy, CreatedOn, ModifiedBy, ModifiedOn]
						wc.setComponentGroupId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_GROUPCOMPONENTID)));
						wc.setComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_COMPONENTID)));
						wc.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_CREATEDBY)));
						wc.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_CREATEDON)));
						wc.setFromDate(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_FROMDATE)));
						wc.setGroupComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_GROUPCOMPONENTID)));
						wc.setGroupComponentName(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_GROUPCOMPONENTNAME)));
						String LocKM = cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_LOCATIOKM));
						wc.setLocationKM(Double.parseDouble(String.valueOf(LocKM.equalsIgnoreCase("NULL")?0.0:LocKM)));
						wc.setModifiedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_MODIFIEDBY)));
						wc.setModifiedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_MODIFIEDON)));
						wc.setSubComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_SUBCOMPONENTID)));
						wc.setToDate(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_TODATE)));
						wc.setWorkChainageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_WORKCAHAINAGEID)));
						wc.setWorkComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_WORKCOMPONENTID)));
						wc.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_WORKID)));
						lstWorkComponents.add(wc);
						cursor.moveToNext();
					}
				}
			}

		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return lstWorkComponents;
	}

	public HashMap<Integer, String> getMasterComponents() {
		// TODO Auto-generated method stub
		HashMap<Integer, String> hmComponent = new HashMap<Integer, String>();
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_MASTER_COMPONENTS);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						hmComponent.put(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_MASTER_COMPONENTS_COMPONENTID)), cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_MASTER_COMPONENTS_COMPONENTDESC)));
						cursor.moveToNext();
					}
				}
			}

		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return hmComponent;
	}

	public long insertIntoLoginInfo(Login_Info logininfo) {
		long insertVal = 0;
		ContentValues values = new ContentValues();
		values.put(DBConstants.COLUMN_LOGIN_INFO_LOGINID, logininfo.getLoginId());
		values.put(DBConstants.COLUMN_LOGIN_INFO_PASSWORD, logininfo.getPassword());
		values.put(DBConstants.COLUMN_LOGIN_INFO_OFFICERNAME, logininfo.getOfficerName());
		values.put(DBConstants.COLUMN_LOGIN_INFO_ACTIVATED, "");
		values.put(DBConstants.COLUMN_LOGIN_INFO_ACTIVATEDON,"");
		try{
			baseDao.open();
			insertVal = baseDao.Insert(DBConstants.TABLE_LOGIN_INFO, values);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			baseDao.close();
		}
		return insertVal;
	}

	public HashMap<String, Object> getDataToStatusSpinner() {
		// TODO Auto-generated method stub
		HashMap<String, Object> hmStatus = new HashMap<String, Object>();
		HashMap<String, Integer> hmStatusSpinner = new HashMap<String, Integer>();
		List<String> lstStatusNames = new ArrayList<String>();
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_MASTER_WORKSTATUS);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						lstStatusNames.add(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_MASTER_WORKSTATUS_WORKSTATUSDESCRIPTION)));
						hmStatusSpinner.put(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_MASTER_WORKSTATUS_WORKSTATUSDESCRIPTION)), cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_MASTER_WORKSTATUS_WORKSTATUSID)));
						cursor.moveToNext();
					}
				}
			}


		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		hmStatus.put("List", lstStatusNames);
		hmStatus.put("Hashmap", hmStatusSpinner);

		return hmStatus;

	}
	public int getLatestWorkComponentUpdationId() {
		// TODO Auto-generated method stub
		int latestId  = 0;
		baseDao.open();
		Cursor cursor = null;
		try{
			cursor = baseDao.RawQuery("select max(WorkComponentUpdationId) from Work_Component_UpdateStatus", null);
			if(cursor != null){
				if(cursor.getCount()>0){
					latestId = cursor.getInt(0);
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return latestId;
	}
	public long insertIntoWorkComponentUpdationStatus(
			Work_Component_UpdateStatus wcu) {
		// TODO Auto-generated method stub
		long insertVal = 0;
		contentValues = new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTUPDATIONID, wcu.getWorkComponentUpdationId());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTID, wcu.getWorkComponentId());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKID, wcu.getWorkId());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_SUBWORKCOMPONENTSTAGE, wcu.getSubComponentStage());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_FROMKM, wcu.getFromKM());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_TOKM, wcu.getToKM());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_LATTITUDE, wcu.getLattitude());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_LONGITUDE, wcu.getLongitude());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSTYPE, wcu.getWorkStatusType());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORSTATUSDESCRIPTION, wcu.getWorkStatusDescription());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSASON, wcu.getWorkStatusAsOn());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSUPDATEDON, wcu.getWorkStatusUpdatedOn());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDBY, wcu.getCreatedBy());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDON, wcu.getCreatedOn());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_MODIFIEDBY, wcu.getModifiedBy());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_MODIFIEDON, wcu.getModifiedOn());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_ACTUALSTARTDATE, wcu.getActualStartDate());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_ACTUALENDDATE, wcu.getActualEndDate());
		//		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_XMLID, "NULL");

		try{
			baseDao.open();
			insertVal = baseDao.Insert(DBConstants.TABLE_WORK_COMPONENT_UPDATESTATUS, contentValues);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			baseDao.close();
		}
		return insertVal;
	}

	public int getLatestWorkComponentUpdationPhotoId(String workid, String workComponentUpdationId) {
		// TODO Auto-generated method stub
		int latestId  = 0;
		List<String> lst;
		Cursor cursor = null;
		try{
			lst = new ArrayList<String>();
			baseDao.open();
			cursor = baseDao.RawQuery("select max(PhotoId) from Work_Component_Updations_Photo where WorkId = "+workid+" and WorkComponentUpdationId= "+workComponentUpdationId+"", null);
			if(cursor != null){
				if(cursor.getCount()>0){
					latestId = cursor.getInt(0);
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return latestId;
	}

	public long insertIntoGetWorksForSynchronization(Work_Main wm) {
		long insertVal = 0;
		contentValues = new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_MAIN_WORKID, wm.getWorkId());
		contentValues.put(DBConstants.COLUMN_WORK_MAIN_WORKNAME,wm.getWorkName());
		contentValues.put(DBConstants.COLUMN_WORK_MAIN_WORKTYPEID,wm.getWorkTypeId());
		contentValues.put(DBConstants.COLUMN_WORK_MAIN_WORKTYPEDESCRIPTION,wm.getWorkTypeDescription());
		contentValues.put(DBConstants.COLUMN_WORK_MAIN_CREATEDBY,wm.getCreatedBy());
		contentValues.put(DBConstants.COLUMN_WORK_MAIN_CREATEON,wm.getCreatedOn());
		try{
			baseDao.open();
			insertVal = baseDao.Insert(DBConstants.TABLE_WORK_MAIN, contentValues);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			baseDao.close();
		}
		return insertVal;
	}


	public List<String> getworkdescription(String username){
		String args[] ={username};
		Cursor cursor = null;
		List<String> lst = null;
		try{
			lst = new ArrayList<String>();
			baseDao.open();
			//			select distinct(wm.WorkId) as present,* from Work_Main wm where wm.CreatedBy =? and wm.WorkId not in (select wch.WorkId from Work_Chainage wch,Work_Components wco where wch.WorkId=wco.WorkId)
			//			cursor  = baseDao.Query(DBConstants.TABLE_WORK_MAIN,DBConstants.COLUMN_WORK_MAIN_CREATEDBY+ " =? ",args);
			cursor  = baseDao.RawQuery("select distinct(wm.WorkId) as present,* from Work_Main wm where wm.CreatedBy =? and wm.WorkId in (select wch.WorkId from Work_Chainage wch,Work_Components wco where wch.WorkId=wco.WorkId)", args);
			int count = cursor.getCount();
			if(count > 0){
				while(!cursor.isAfterLast()){
					lst.add(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_MAIN_WORKNAME)));
					cursor.moveToNext();
				}	
			}
		}
		catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return lst;
	}

	public long insertIntoComponentUpdationsPhoto(
			Work_Component_Updations_Photo wcup) {
		// TODO Auto-generated method stub
		long insertVal = 0;
		contentValues = new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKCOMPONENTUPDATIONID, wcup.getWorkComponentUpdationId());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKID, wcup.getWorkId());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTOID, wcup.getPhotoId());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTO, wcup.getPhoto());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_LATTITUDE, wcup.getLattitude());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_LONGITUDE, wcup.getLongtitude());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTOTAKENON, wcup.getPhotoTakenOn());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_CREATEDBY, wcup.getCreatedBy());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_CREATEDON, wcup.getCreatedOn());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_MODIFIEDBY, wcup.getModifiedBy());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_MODIFIEDON, wcup.getModifiedOn());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_XMLID, "NULL");
		try{
			baseDao.open();
			insertVal = baseDao.Insert(DBConstants.TABLE_WORK_COMPONENT_UPDATIONS_PHOTO, contentValues);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			baseDao.close();
		}
		return insertVal;
	}
	public HashMap<String, Object> getDataToSubStageSpinner() {
		// TODO Auto-generated method stub
		HashMap<String, Object> hmStatus = new HashMap<String, Object>();
		HashMap<String, Integer> hmStatusSpinner = new HashMap<String, Integer>();
		List<String> lstStatusNames = new ArrayList<String>();
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_MASTER_SUBCOMPONENTSTAGE);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						lstStatusNames.add(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_MASTER_SUBCOMPONENTSTAGE_SUBCOMPONENTSTAGEDESCRIPTION)));
						hmStatusSpinner.put(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_MASTER_SUBCOMPONENTSTAGE_SUBCOMPONENTSTAGEDESCRIPTION)), cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_MASTER_SUBCOMPONENTSTAGE_SUBCOMPONENTSTAGEID)));
						cursor.moveToNext();
					}
				}
			}

		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		hmStatus.put("List", lstStatusNames);
		hmStatus.put("Hashmap", hmStatusSpinner);

		return hmStatus;
	}
	public List<Work_Component_UpdateStatus> getAllWork_Component_UpdationStatus() {
		// TODO Auto-generated method stub
		List<Work_Component_UpdateStatus> lstUpdateStatus = new ArrayList<Work_Component_UpdateStatus>();
		String[] selArgs = {AppUserDetails.getUsername(),"NULL"};
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COMPONENT_UPDATESTATUS,DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDBY+"=? and "+DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						Work_Component_UpdateStatus wcus = new Work_Component_UpdateStatus();
						wcus.setActualEndDate(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_ACTUALENDDATE)));
						wcus.setActualStartDate(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_ACTUALSTARTDATE)));
						wcus.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDBY)));
						wcus.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDON)));
						wcus.setFromKM(Double.parseDouble(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_FROMKM))));
						wcus.setLattitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_LATTITUDE)));
						wcus.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_LONGITUDE)));
						wcus.setModifiedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_MODIFIEDBY)));
						wcus.setModifiedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_MODIFIEDON)));
						wcus.setSubComponentStage(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_SUBWORKCOMPONENTSTAGE)));
						wcus.setToKM(Double.parseDouble(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_TOKM))));
						wcus.setWorkComponentUpdationId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTUPDATIONID)));
						wcus.setWorkComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTID)));
						wcus.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKID)));
						wcus.setWorkStatusAsOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSASON)));
						wcus.setWorkStatusDescription(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORSTATUSDESCRIPTION)));
						wcus.setWorkStatusType(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSTYPE)));
						wcus.setWorkStatusUpdatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSUPDATEDON)));
						lstUpdateStatus.add(wcus);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstUpdateStatus;
	}

	public HashMap<String,Object> getGroupidandname(int workrowid){
		String args[] = {String.valueOf(workrowid)};
		HashMap<String,Object> hm = new HashMap<String, Object>();
		List<String> lst = new ArrayList<String>();

		HashMap<String, Integer> description=new  HashMap<String, Integer>();
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.RawQuery("select wm.WorkTypeId, MC.ComponentGroupId,mc.GroupName,COUNT(mc.ComponentGroupId) from Work_Main wm inner join Master_WorkType_Component mwc on mwc.WorkTypeId=wm.WorkTypeId inner join Master_ComponentGroup MC on mc.ComponentId=mwc.ComponentId and mc.ComponentGroupId=mwc.ComponentGroupId where WorkId ="+workrowid+ " group by wm.WorkTypeId,MC.ComponentGroupId,mc.GroupName",null);
			if(cursor != null){
				while(!cursor.isAfterLast()){
					lst.add(cursor.getString(2));
					description.put(cursor.getString(2),cursor.getInt(1));
					cursor.moveToNext();
				}
			}

		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		hm.put("Multivalue",description);
		hm.put("lst",lst);
		return hm;
	}
	public int getworkrowid(String Desc){
		String args[] ={Desc};
		Cursor cursor = null;
		int id =0;
		try{

			baseDao.open();

			cursor  = baseDao.Query(DBConstants.TABLE_WORK_MAIN,DBConstants.COLUMN_WORK_MAIN_WORKNAME+ " =? ",args);
			int count = cursor.getCount();
			if(count > 0){

				id = cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_MAIN_WORKID));


			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return id;
	}
	public List<Work_Component_Updations_Photo> getAllWork_Component_UpdationPhotos(
			String username) {
		// TODO Auto-generated method stub
		List<Work_Component_Updations_Photo> lstUpdateStatus = new ArrayList<Work_Component_Updations_Photo>();
		String[] selArgs = {AppUserDetails.getUsername(),"NULL"};
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COMPONENT_UPDATIONS_PHOTO,DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_CREATEDBY+"=? and "+DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						Work_Component_Updations_Photo wcus = new Work_Component_Updations_Photo();
						wcus.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_CREATEDBY)));
						wcus.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_CREATEDON)));
						wcus.setLattitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_LATTITUDE)));
						wcus.setLongtitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_LONGITUDE)));
						wcus.setModifiedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_MODIFIEDBY)));
						wcus.setModifiedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_MODIFIEDON)));
						wcus.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKID)));
						wcus.setPhoto(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTO)));
						wcus.setPhotoId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTOID)));
						wcus.setPhotoTakenOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTOTAKENON)));
						wcus.setWorkComponentUpdationId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKCOMPONENTUPDATIONID)));
						wcus.setServerId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_SERVERID)));
						lstUpdateStatus.add(wcus);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstUpdateStatus;
	}

	public List<TablesWc> getdataforgrid(int workrowid){
		String args[] = {String.valueOf(workrowid)};
		Cursor cursor = null;
		List<TablesWc> lst = new ArrayList<TablesWc>();
		try{
			baseDao.open();
			cursor = baseDao.RawQuery("select  wc.ComponentGroupId,mc.GroupName,wcp.GroupComponentId,wcp.GroupComponentName,MIN(wc.FromKM) as FromDist,MAX(wc.ToKM) as ToDist from Work_Chainage wc inner join Work_Components wcp on wcp.WorkId=wc.WorkId and wc.ComponentGroupId=wcp.ComponentGroupId and wc.GroupComponentId=wcp.GroupComponentId  inner join Master_ComponentGroup mc on mc.ComponentGroupId=wc.ComponentGroupId where wcp.workid=? group by wc.ComponentGroupId,mc.GroupName, wcp.GroupComponentId,wcp.GroupComponentName", args);
			if(cursor != null){
				while(!cursor.isAfterLast()){
					TablesWc wc = new TablesWc();
					wc.setComponentgroupid(cursor.getString(0));
					wc.setGroupname(cursor.getString(1));
					wc.setGroupcomponentid(cursor.getString(2));
					wc.setGroupcomonentname(cursor.getString(3));
					wc.setFromdistance(cursor.getString(4));
					wc.setTodistance(cursor.getString(5));
					lst.add(wc);

					cursor.moveToNext();
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return lst;
	}

	public long insertintoworkchainage(Work_Chainage chainage){
		long cursor;
		ContentValues values = new ContentValues();
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_WORKID, chainage.getWorkId());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_WORKCHAINAGEID, chainage.getWorkChainageId());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_TOKM, chainage.getToKM());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_TODATE, chainage.getToDate());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_MODIFIEDON, chainage.getModifiedOn());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_MODIFIEDBY, chainage.getModifiedBy());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_GROUPCOMPONENTID, chainage.getGroupComponentId());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_FROMKM, chainage.getFromKM());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_FROMDATE, chainage.getFromDate());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_CREATEDON, chainage.getCreatedOn());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_CREATEDBY, chainage.getCreatedBy());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_COMPONENTGROUPID, chainage.getComponentGroupId());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_CHAINAGENAME, chainage.getChainageName());
		try{
			baseDao.open();
			cursor = baseDao.Insert(DBConstants.TABLE_WORK_CHAINAGE, values);
		}finally{
			baseDao.close();
		}
		return cursor;
	}

	public long insertintoworkcomponents(Work_Components components){
		long cursor;
		ContentValues values = new ContentValues();
		values.put(DBConstants.COLUMN_WORK__COMPONENTS_WORKID, components.getWorkId());
		values.put(DBConstants.COLUMN_WORK__COMPONENTS_WORKCOMPONENTID, components.getWorkComponentId());
		values.put(DBConstants.COLUMN_WORK__COMPONENTS_WORKCAHAINAGEID, components.getWorkChainageId());
		values.put(DBConstants.COLUMN_WORK__COMPONENTS_TODATE, components.getToDate());
		values.put(DBConstants.COLUMN_WORK__COMPONENTS_SUBCOMPONENTID, components.getSubComponentId());
		values.put(DBConstants.COLUMN_WORK__COMPONENTS_MODIFIEDON, components.getModifiedOn());
		values.put(DBConstants.COLUMN_WORK__COMPONENTS_MODIFIEDBY, components.getModifiedBy());
		values.put(DBConstants.COLUMN_WORK__COMPONENTS_LOCATIOKM, components.getLocationKM());
		values.put(DBConstants.COLUMN_WORK__COMPONENTS_GROUPCOMPONENTNAME, components.getGroupComponentName());
		values.put(DBConstants.COLUMN_WORK__COMPONENTS_GROUPCOMPONENTID, components.getGroupComponentId());
		values.put(DBConstants.COLUMN_WORK__COMPONENTS_FROMDATE, components.getFromDate());
		values.put(DBConstants.COLUMN_WORK__COMPONENTS_CREATEDON, components.getCreatedOn());
		values.put(DBConstants.COLUMN_WORK__COMPONENTS_CREATEDBY, components.getCreatedBy());
		values.put(DBConstants.COLUMN_WORK__COMPONENTS_COMPONENTID, components.getComponentId());
		values.put(DBConstants.COLUMN_WORK__COMPONENTS_COMPONENTGROUPID, components.getComponentGroupId());


		try{
			baseDao.open();
			cursor = baseDao.Insert(DBConstants.TABLE_WORK_COMPONENTS, values);
		}finally{
			baseDao.close();
		}
		return cursor;
	}
	public String getWorkNameDesc(String workId) {
		// TODO Auto-generated method stub
		Cursor cursor = null;
		try{
			String[] selArgs = {workId};
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_MAIN, DBConstants.COLUMN_WORK_MAIN_WORKID +"=?", selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					return cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_MAIN_WORKNAME));
				}
			}

		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return "";
	}
	public String getcompentname(int compid,int subcompid){
		String str="";
		String args[] = {String.valueOf(compid),String.valueOf(subcompid)};
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_MASTER_SUBCOMPONENT, DBConstants.COLUMN_MASTER_SUBCOMPONENT_COMPONENTID+ " =? and " + DBConstants.COLUMN_MASTER_SUBCOMPONENT_SUBCOMPONENTID+ " =? ", args);
			if(cursor != null){
				if(!cursor.isAfterLast()){
					str = cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_MASTER_SUBCOMPONENT_SUBCOMPONENTNAME));
					cursor.moveToNext();
				}
			}

		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return str;
	}

	public HashMap<String, Object> getAllMasterStageValues() {
		// TODO Auto-generated method stub
		HashMap<String, Object> hm = new HashMap<String, Object>();
		HashMap<String, Integer> hmStage = new HashMap<String, Integer>();
		List<String> lstStage = new ArrayList<String>();
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_MASTER_COORDINATESTAGE);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						lstStage.add(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_MASTER_COORDINATESTAGE_STAGEDESCRIPTION)));
						hmStage.put(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_MASTER_COORDINATESTAGE_STAGEDESCRIPTION)), cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_MASTER_COORDINATESTAGE_STAGEID)));
						cursor.moveToNext();
					}
				}
			}

		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		hm.put("List", lstStage);
		hm.put("Hashmap", hmStage);
		return hm;
	}
	/*	public Work_Components getWorkComponents(String workId,
		String componentGroupId, String groupComponentId, String valueOf) {
	// TODO Auto-generated method stub
	Work_Components wc;
	String[] selArgs = {workId,componentId,groupComponentId,chainageId};
	Cursor cursor = null;
	try{
		baseDao.open();
		cursor = baseDao.Query(DBConstants.TABLE_WORK_COMPONENTS, DBConstants.COLUMN_WORK__COMPONENTS_WORKID +"=? and "+DBConstants.COLUMN_WORK__COMPONENTS_COMPONENTGROUPID+"=? and "+DBConstants.COLUMN_WORK__COMPONENTS_GROUPCOMPONENTID+"=? and "+DBConstants.COLUMN_WORK__COMPONENTS_WORKCAHAINAGEID+"=?", selArgs);
		//			cursor = baseDao.RawQuery("SELECT * FROM Work_Components WHERE WorkId="+workId+" and ComponentGroupId="+componentId+" and GroupComponentId="+groupComponentId+" and WorkChainageId="+chainageId+"", null);
		if(cursor != null){
			if(cursor.getCount() >0){
				while(!cursor.isAfterLast()){
					wc = new Work_Components();
					//[WorkComponentId, WorkId, WorkChainageId, ComponentGroupId, GroupComponentName, GroupComponentId, ComponentId, SubComponentId, LocationKM, FromDate, ToDate, CreatedBy, CreatedOn, ModifiedBy, ModifiedOn]
					wc.setComponentGroupId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_GROUPCOMPONENTID)));
					wc.setComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_COMPONENTID)));
					wc.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_CREATEDBY)));
					wc.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_CREATEDON)));
					wc.setFromDate(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_FROMDATE)));
					wc.setGroupComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_GROUPCOMPONENTID)));
					wc.setGroupComponentName(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_GROUPCOMPONENTNAME)));
					String LocKM = cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_LOCATIOKM));
					wc.setLocationKM(Double.parseDouble(String.valueOf(LocKM.equalsIgnoreCase("NULL")?0.0:LocKM)));
					wc.setModifiedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_MODIFIEDBY)));
					wc.setModifiedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_MODIFIEDON)));
					wc.setSubComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_SUBCOMPONENTID)));
					wc.setToDate(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_TODATE)));
					wc.setWorkChainageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_WORKCAHAINAGEID)));
					wc.setWorkComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_WORKCOMPONENTID)));
					wc.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK__COMPONENTS_WORKID)));
					cursor.moveToNext();
				}
			}
		}

	}catch (Exception e) {
		// TODO: handle exception
		e.printStackTrace();
	}
	finally{
		if(cursor != null){
			if(!cursor.isClosed()){
				cursor.close();
			}
		}
		baseDao.close();
	}
	return wc;
}*/
	public int getLastWorkCoordinatesId() {
		// TODO Auto-generated method stub
		int latWorkCoordinatesId  = 0;
		List<String> lst;
		Cursor cursor = null;
		try{
			lst = new ArrayList<String>();
			baseDao.open();
			cursor = baseDao.RawQuery("select max(Work_CoordinatesId) from Work_Coordinates", null);
			if(cursor != null){
				if(cursor.getCount()>0){
					latWorkCoordinatesId = cursor.getInt(0);
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return latWorkCoordinatesId;
	}
	public int getLastCoordinateIdForThisWork(String workId,
			String componentgroupid, String groupComponentId, String chainageId) {
		// TODO Auto-generated method stub
		int lastCoordinateIdForThisWork  = 0;
		List<String> lst;
		Cursor cursor  = null;
		try{
			lst = new ArrayList<String>();
			baseDao.open();
			cursor = baseDao.RawQuery("select max(CoordinateId) from Work_Coordinates where WorkId = "+workId+" and GroupComponentId = "+groupComponentId+" and ComponentGroupId = "+componentgroupid+" and ChainageId = "+chainageId+"", null);
			if(cursor != null){
				if(cursor.getCount()>0){
					lastCoordinateIdForThisWork = cursor.getInt(0);
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return lastCoordinateIdForThisWork;
	}
	public long addToWorkCoordinatesTable(Work_Coordinates wCoor) {
		// TODO Auto-generated method stub
		long cursor;
		ContentValues values = new ContentValues();
		values.put(DBConstants.COLUMN_WORK_COORDINATES_WORK_COORDINATESID, wCoor.getWork_CoordinatesId());
		values.put(DBConstants.COLUMN_WORK_COORDINATES_COORDINATEID, wCoor.getCoordinateId());
		values.put(DBConstants.COLUMN_WORK_COORDINATES_WORKID, wCoor.getWorkId());
		values.put(DBConstants.COLUMN_WORK_COORDINATES_GROUPCOMPONENTID, wCoor.getGroupComponentId());
		values.put(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTGROUPID, wCoor.getComponentGroupId());
		values.put(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTID, wCoor.getComponentId());
		values.put(DBConstants.COLUMN_WORK_COORDINATES_SUBCOMPONENTID, wCoor.getSubComponentId());
		values.put(DBConstants.COLUMN_WORK_COORDINATES_CHAINAGEID, wCoor.getChainageId());
		values.put(DBConstants.COLUMN_WORK_COORDINATES_STAGEID, wCoor.getStageId());
		values.put(DBConstants.COLUMN_WORK_COORDINATES_LATITUDE, wCoor.getLatitude());
		values.put(DBConstants.COLUMN_WORK_COORDINATES_LONGITUDE, wCoor.getLongitude());
		values.put(DBConstants.COLUMN_WORK_COORDINATES_CREATEDON, wCoor.getCreatedOn());
		values.put(DBConstants.COLUMN_WORK_COORDINATES_CREATEDBY, wCoor.getCreatedBy());
		values.put(DBConstants.COLUMN_WORK_COORDINATES_XMLID, "NULL");


		try{
			baseDao.open();
			cursor = baseDao.Insert(DBConstants.TABLE_WORK_COORDINATES, values);
		}finally{
			baseDao.close();
		}
		return cursor;

	}

	public boolean checkingWorkChainage(int workid,int componentGroupId,int workChainageId)
	{
		String[] args = {String.valueOf(workid),String.valueOf(componentGroupId),String.valueOf(workChainageId)};
		Cursor cursor;
		try{
			baseDao.open();
			cursor = baseDao.RawQuery("select * from Work_Chainage where WorkId=? and ComponentGroupId=? and WorkChainageId=?",args);
			if(cursor!=null){
				if(cursor.getCount()>0){
					return true;
				}
			}
		}catch(Exception e){
			e.printStackTrace();
		}

		return false;
	}
	public boolean checkingWorkComponent(int workid)
	{
		String[] args = {String.valueOf(workid)};
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.RawQuery("select * from Work_Components where WorkComponentId=?",args);
			if(cursor!=null){
				if(cursor.getCount()>0){
					return true;
				}
			}
		}catch(Exception e){
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return false;
	}
	public long updatevaluesChainage(int workid,int componentGroupId,int workChainageId,Work_Chainage chainage)
	{
		long cursor;
		String[] args={String.valueOf(workid),String.valueOf(componentGroupId),String.valueOf(workChainageId)};
		ContentValues values=new ContentValues();
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_WORKID, chainage.getWorkId());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_WORKCHAINAGEID, chainage.getWorkChainageId());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_TOKM, chainage.getToKM());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_TODATE, chainage.getToDate());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_MODIFIEDON, chainage.getModifiedOn());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_MODIFIEDBY, chainage.getModifiedBy());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_GROUPCOMPONENTID, chainage.getGroupComponentId());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_FROMKM, chainage.getFromKM());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_FROMDATE, chainage.getFromDate());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_CREATEDON, chainage.getCreatedOn());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_CREATEDBY, chainage.getCreatedBy());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_COMPONENTGROUPID, chainage.getComponentGroupId());
		values.put(DBConstants.COLUMN_WORK_CHAINAGE_CHAINAGENAME, chainage.getChainageName());
		try{
			baseDao.open();
			cursor = baseDao.Update(DBConstants.TABLE_WORK_CHAINAGE, values, DBConstants.COLUMN_WORK_CHAINAGE_WORKID +"=? and "+DBConstants.COLUMN_WORK_CHAINAGE_COMPONENTGROUPID +"=? and "+DBConstants.COLUMN_WORK__COMPONENTS_WORKCAHAINAGEID+"=?", args);
		}finally{
			baseDao.close();
		}
		return cursor;

	}
	public long updatevaluesComponents(int workid,int componentGroupId,int workChainageId,Work_Components components)
	{
		long cursor;
		//		String[] args={String.valueOf(workid),String.valueOf(componentGroupId),String.valueOf(workChainageId)};
		String[] args={String.valueOf(components.getWorkComponentId())};
		ContentValues contentValues=new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK__COMPONENTS_WORKCOMPONENTID,components.getWorkComponentId());
		contentValues.put(DBConstants.COLUMN_WORK__COMPONENTS_WORKID,components.getWorkId());
		contentValues.put(DBConstants.COLUMN_WORK__COMPONENTS_WORKCAHAINAGEID,components.getWorkChainageId());
		contentValues.put(DBConstants.COLUMN_WORK__COMPONENTS_COMPONENTGROUPID,components.getComponentGroupId());
		contentValues.put(DBConstants.COLUMN_WORK__COMPONENTS_GROUPCOMPONENTID,components.getGroupComponentId());
		contentValues.put(DBConstants.COLUMN_WORK__COMPONENTS_GROUPCOMPONENTNAME,components.getGroupComponentName());
		contentValues.put(DBConstants.COLUMN_WORK__COMPONENTS_COMPONENTID,components.getComponentId());
		contentValues.put(DBConstants.COLUMN_WORK__COMPONENTS_SUBCOMPONENTID,components.getSubComponentId());
		contentValues.put(DBConstants.COLUMN_WORK__COMPONENTS_LOCATIOKM,components.getLocationKM());
		contentValues.put(DBConstants.COLUMN_WORK__COMPONENTS_FROMDATE,components.getFromDate());
		contentValues.put(DBConstants.COLUMN_WORK__COMPONENTS_TODATE,components.getToDate());
		contentValues.put(DBConstants.COLUMN_WORK__COMPONENTS_CREATEDBY,components.getCreatedBy());
		contentValues.put(DBConstants.COLUMN_WORK__COMPONENTS_CREATEDON,components.getCreatedOn());
		contentValues.put(DBConstants.COLUMN_WORK__COMPONENTS_MODIFIEDBY,components.getModifiedBy());
		contentValues.put(DBConstants.COLUMN_WORK__COMPONENTS_MODIFIEDON,components.getModifiedOn());
		try{
			baseDao.open();
			cursor = baseDao.Update(DBConstants.TABLE_WORK_COMPONENTS, contentValues, DBConstants.COLUMN_WORK__COMPONENTS_WORKCOMPONENTID +"=? ", args);
		}finally{
			baseDao.close();
		}
		return cursor;

	}

	public HashMap<String,Object> getWorkidFromChainageAndComponent(String name){
		String args[] = {name};
		HashMap<String,Object> hm;
		List<String> lst1 = new ArrayList<String>();

		HashMap<String, Integer> description=new  HashMap<String, Integer>();
		Cursor cursor = null;
		try{
			hm = new HashMap<String,Object>();
			baseDao.open();
			cursor = baseDao.RawQuery("select distinct(wm.WorkId) as present,* from Work_Main wm where wm.CreatedBy =? and wm.WorkId not in (select wch.WorkId from Work_Chainage wch,Work_Components wco where wch.WorkId=wco.WorkId)",args);
			if(cursor != null){
				while(!cursor.isAfterLast()){
					lst1.add(cursor.getString(2));
					description.put(cursor.getString(2),cursor.getInt(1));
					cursor.moveToNext();
				}
			}

		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		hm.put("Multivalue",description);
		hm.put("lst1",lst1);
		return hm;
	}

	public boolean checkingWorkComponentUpdationStatus(int workComponentUpdationId)
	{
		String[] args = {String.valueOf(workComponentUpdationId)};
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.RawQuery("select * from Work_Component_UpdateStatus where WorkComponentUpdationId=?",args);
			if(cursor!=null){
				if(cursor.getCount()>0){
					return true;
				}
			}
		}catch(Exception e){
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return false;
	}

	public long updatevaluesGetWorkComponentUpdateStaus(int workComponentUpdationId,Work_Component_UpdateStatus wcu)
	{
		long cursor;
		String[] args={String.valueOf(workComponentUpdationId)};
		ContentValues contentValues=new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTUPDATIONID, wcu.getWorkComponentUpdationId());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTID, wcu.getWorkComponentId());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKID, wcu.getWorkId());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_SUBWORKCOMPONENTSTAGE, wcu.getSubComponentStage());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_FROMKM, wcu.getFromKM());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_TOKM, wcu.getToKM());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_LATTITUDE, wcu.getLattitude());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_LONGITUDE, wcu.getLongitude());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSTYPE, wcu.getWorkStatusType());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORSTATUSDESCRIPTION, wcu.getWorkStatusDescription());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSASON, wcu.getWorkStatusAsOn());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSUPDATEDON, wcu.getWorkStatusUpdatedOn());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDBY, wcu.getCreatedBy());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDON, wcu.getCreatedOn());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_MODIFIEDBY, wcu.getModifiedBy());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_MODIFIEDON, wcu.getModifiedOn());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_ACTUALSTARTDATE, wcu.getActualStartDate());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_ACTUALENDDATE, wcu.getActualEndDate());

		try{
			baseDao.open();
			cursor = baseDao.Update(DBConstants.TABLE_WORK_COMPONENT_UPDATESTATUS, contentValues, DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTUPDATIONID +"=? ", args);
		}finally{
			baseDao.close();
		}
		return cursor;

	}

	public HashMap<String, String> getto(int workid,int componentgroupid,int workchainageid){
		String[] args = {String.valueOf(workid),String.valueOf(componentgroupid),String.valueOf(workchainageid)};
		HashMap<String,String> hm = new HashMap<String, String>();
		Cursor cursor = null;
		String str = null,str1 = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_CHAINAGE, DBConstants.COLUMN_WORK_CHAINAGE_WORKID +" = ? and "+ DBConstants.COLUMN_WORK_CHAINAGE_COMPONENTGROUPID +" = ? and "+DBConstants.COLUMN_WORK_CHAINAGE_WORKCHAINAGEID + " =? ",args);
			if(cursor !=null){
				while(!cursor.isAfterLast()){
					str = (cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_CHAINAGE_FROMKM)));	

					str1 = (cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_CHAINAGE_TOKM)));	
					cursor.moveToNext();
				}
			}
			hm.put("fromdistance", str);
			hm.put("Todistance", str1);
		}finally{
			if(cursor != null){
				if(!cursor.isClosed())
				{
					cursor.close();
				}
				baseDao.close();
			}
		}
		return hm;
	}
	public int getLatestPhotoId(int coordinateId, int work_CoordinatesId) {
		// TODO Auto-generated method stub
		int lastPhotoId  = 0;
		List<String> lst;
		Cursor cursor = null;
		try{
			lst = new ArrayList<String>();
			baseDao.open();
			cursor = baseDao.RawQuery("select max(PhotoId) from Work_CoordinatesPhotos where Work_CoordinatesId="+work_CoordinatesId+" and CoordinateId = "+coordinateId+"", null);
			if(cursor != null){
				if(cursor.getCount()>0){
					lastPhotoId = cursor.getInt(0);
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return lastPhotoId;
	}
	public long insertIntoWorkCoordinatePhoto(WorkCoordinatePhotos wcp) {
		// TODO Auto-generated method stub
		long res;
		ContentValues contentValues=new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_WORK_COORDINATESID, wcp.getWork_CoordinatesId());
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_COORDINATEID, wcp.getCoordinateId());
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOID, wcp.getPhotoId());
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOPATH, wcp.getPhotoPath());
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOCAPTION, wcp.getPhotoCaption());
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_LATITUDE, wcp.getLatitude());
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_LONGITUDE, wcp.getLongitude());
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOTAKENON, wcp.getPhotoTakenOn());
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOTAKENBY, wcp.getPhotoTakenBy());
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOSTATE, wcp.getWorkState());
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_XMLID, "NULL");

		try{
			baseDao.open();
			res = baseDao.Insert(DBConstants.TABLE_WORK_COORDINATESPHOTOS, contentValues);
		}finally{
			baseDao.close();
		}
		return res;
	}
	public String getLastXMLId(String username, String tableName, String isSync) {
		// TODO Auto-generated method stub
		String lastXMLId  = null;
		List<String> lst;
		Cursor cursor = null;
		try{
			lst = new ArrayList<String>();
			baseDao.open();
			cursor = baseDao.RawQuery("select XMLId from XMLSyncValidation where Appuser='"+username+"' and XMLTableName='"+tableName+"' and isSynced='"+isSync+"'", null);
			if(cursor != null){
				if(cursor.getCount()>0){
					while(!cursor.isAfterLast()){
						lastXMLId = cursor.getString(0);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return lastXMLId;
	}



	public boolean checkingWorkMain(int workId)
	{
		String[] args = {String.valueOf(workId)};
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.RawQuery("select * from Work_Main where WorkId=?",args);
			if(cursor!=null){
				if(cursor.getCount()>0){
					return true;
				}
			}
		}catch(Exception e){
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return false;
	}
	public long updatevaluesWorkMain(int workId,Work_Main wm)
	{
		long cursor;
		String[] args={String.valueOf(workId)};
		ContentValues contentValues=new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_MAIN_WORKID, wm.getWorkId());
		contentValues.put(DBConstants.COLUMN_WORK_MAIN_WORKNAME,wm.getWorkName());
		contentValues.put(DBConstants.COLUMN_WORK_MAIN_WORKTYPEID,wm.getWorkTypeId());
		contentValues.put(DBConstants.COLUMN_WORK_MAIN_WORKTYPEDESCRIPTION,wm.getWorkTypeDescription());
		contentValues.put(DBConstants.COLUMN_WORK_MAIN_CREATEDBY,wm.getCreatedBy());
		contentValues.put(DBConstants.COLUMN_WORK_MAIN_CREATEON,wm.getCreatedOn());
		try{
			baseDao.open();
			cursor = baseDao.Update(DBConstants.TABLE_WORK_MAIN, contentValues, DBConstants.COLUMN_WORK_MAIN_WORKID +"=? ", args);
		}finally{
			baseDao.close();
		}
		return cursor;

	}
	public List<Work_Component_UpdateStatus> getAllWork_Component_UpdationStatus(
			String xmlId) {
		// TODO Auto-generated method stub
		List<Work_Component_UpdateStatus> lstUpdateStatus = new ArrayList<Work_Component_UpdateStatus>();
		String[] selArgs = {AppUserDetails.getUsername(),String.valueOf(xmlId)};
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COMPONENT_UPDATESTATUS,DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDBY+"=? and "+DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						Work_Component_UpdateStatus wcus = new Work_Component_UpdateStatus();
						wcus.setActualEndDate(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_ACTUALENDDATE)));
						wcus.setActualStartDate(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_ACTUALSTARTDATE)));
						wcus.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDBY)));
						wcus.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDON)));
						wcus.setFromKM(Double.parseDouble(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_FROMKM))));
						wcus.setLattitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_LATTITUDE)));
						wcus.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_LONGITUDE)));
						wcus.setModifiedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_MODIFIEDBY)));
						wcus.setModifiedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_MODIFIEDON)));
						wcus.setSubComponentStage(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_SUBWORKCOMPONENTSTAGE)));
						wcus.setToKM(Double.parseDouble(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_TOKM))));
						wcus.setWorkComponentUpdationId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTUPDATIONID)));
						wcus.setWorkComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTID)));
						wcus.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKID)));
						wcus.setWorkStatusAsOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSASON)));
						wcus.setWorkStatusDescription(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORSTATUSDESCRIPTION)));
						wcus.setWorkStatusType(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSTYPE)));
						wcus.setWorkStatusUpdatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSUPDATEDON)));
						lstUpdateStatus.add(wcus);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstUpdateStatus;
	}
	public void updateXMLSync(String wcuRes, String lastXMlidForAppUser) {
		// TODO Auto-generated method stub
		long cursor;
		String[] args={String.valueOf(lastXMlidForAppUser)};
		ContentValues contentValues=new ContentValues();
		contentValues.put(DBConstants.COLUMN_XMLSYNCVALIDATION_ISSYNCED,wcuRes);
		try{
			baseDao.open();
			cursor = baseDao.Update(DBConstants.TABLE_XMLSYNCVALIDATION, contentValues, DBConstants.COLUMN_XMLSYNCVALIDATION_XMLID +"=? ", args);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			baseDao.close();
		}

	}
	public void updateXMLIDForWorkComponentUpdateStatus(String workUpdationStatusId,
			String xmlId) {
		// TODO Auto-generated method stub
		long cursor;
		String[] args={workUpdationStatusId};
		ContentValues contentValues=new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_XMLID,xmlId);
		try{
			baseDao.open();
			cursor = baseDao.Update(DBConstants.TABLE_WORK_COMPONENT_UPDATESTATUS, contentValues, DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTUPDATIONID +"=? ", args);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			baseDao.close();
		}
	}
	public long insertIntoXMLSync(String lastXMLid, String tableName, String username) {
		// TODO Auto-generated method stub
		long res = 0;
		ContentValues contentValues=new ContentValues();
		contentValues.put(DBConstants.COLUMN_XMLSYNCVALIDATION_XMLID, lastXMLid);
		contentValues.put(DBConstants.COLUMN_XMLSYNCVALIDATION_XMLTABLENAME, tableName);
		contentValues.put(DBConstants.COLUMN_XMLSYNCVALIDATION_APPUSER, username);
		contentValues.put(DBConstants.COLUMN_XMLSYNCVALIDATION_ISSYNCED, "N");

		try{
			baseDao.open();
			res = baseDao.Insert(DBConstants.TABLE_XMLSYNCVALIDATION, contentValues);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			baseDao.close();
		}
		return res;
	}
	public Work_Component_Updations_Photo getWorkComponentUpdationsPhoto(
			String username, String lastXMlidForAppUserPhoto) {
		// TODO Auto-generated method stub
		String[] selArgs = {username,String.valueOf(lastXMlidForAppUserPhoto)};
		Cursor cursor = null;
		Work_Component_Updations_Photo wcus = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COMPONENT_UPDATIONS_PHOTO,DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_CREATEDBY+"=? and "+DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					wcus = new Work_Component_Updations_Photo();
					//					while(!cursor.isAfterLast()){
					wcus.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_CREATEDBY)));
					wcus.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_CREATEDON)));
					wcus.setLattitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_LATTITUDE)));
					wcus.setLongtitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_LONGITUDE)));
					wcus.setModifiedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_MODIFIEDBY)));
					wcus.setModifiedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_MODIFIEDON)));
					wcus.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKID)));
					wcus.setPhoto(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTO)));
					wcus.setPhotoId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTOID)));
					wcus.setPhotoTakenOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTOTAKENON)));
					wcus.setWorkComponentUpdationId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKCOMPONENTUPDATIONID)));
					wcus.setServerId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_SERVERID)));
					//						cursor.moveToNext();
					//					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return wcus;
	}
	public void updateWorkComponentUpdationsPhoto(String lastXMLId,
			Work_Component_Updations_Photo wcup) {
		// TODO Auto-generated method stub
		long cursor;
		String[] args={String.valueOf(wcup.getWorkComponentUpdationId()),String.valueOf(wcup.getWorkId()),String.valueOf(wcup.getPhotoId())};
		ContentValues contentValues=new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_XMLID,lastXMLId);
		try{
			baseDao.open();
			cursor = baseDao.Update(DBConstants.TABLE_WORK_COMPONENT_UPDATIONS_PHOTO, contentValues, DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKCOMPONENTUPDATIONID +"=? and "+DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKID +"=? and "+DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTOID+"=?", args);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			baseDao.close();
		}
	}
	public List<Work_Coordinates> getAllWork_Coordinates(
			int lastXMlidForWorkCoor) {
		// TODO Auto-generated method stub
		String[] selArgs = {String.valueOf(lastXMlidForWorkCoor)};
		List<Work_Coordinates> lstWC = new ArrayList<Work_Coordinates>();
		Cursor cursor = null;
		Work_Component_Updations_Photo wcus = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COORDINATES,DBConstants.COLUMN_WORK_COORDINATES_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					wcus = new Work_Component_Updations_Photo();
					while(!cursor.isAfterLast()){
						Work_Coordinates wc = new Work_Coordinates();
						wc.setChainageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CHAINAGEID)));
						wc.setComponentGroupId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTGROUPID)));
						wc.setComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTID)));
						wc.setCoordinateId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COORDINATEID)));
						wc.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CREATEDBY)));
						wc.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CREATEDON)));
						wc.setGroupComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_GROUPCOMPONENTID)));
						wc.setLatitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_LATITUDE)));
						wc.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_LONGITUDE)));
						wc.setStageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_STAGEID)));
						wc.setSubComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_SUBCOMPONENTID)));
						wc.setWork_CoordinatesId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_WORK_COORDINATESID)));
						wc.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKID)));
						lstWC.add(wc);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstWC;
	}
	public List<Work_Coordinates> getAllWork_Coordinates(String username) {
		// TODO Auto-generated method stub
		String[] selArgs = {username,"NULL"};
		List<Work_Coordinates> lstWC = new ArrayList<Work_Coordinates>();
		Cursor cursor = null;
		Work_Component_Updations_Photo wcus = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COORDINATES,DBConstants.COLUMN_WORK_COORDINATES_CREATEDBY+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					wcus = new Work_Component_Updations_Photo();
					while(!cursor.isAfterLast()){
						Work_Coordinates wc = new Work_Coordinates();
						wc.setChainageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CHAINAGEID)));
						wc.setComponentGroupId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTGROUPID)));
						wc.setComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTID)));
						wc.setCoordinateId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COORDINATEID)));
						wc.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CREATEDBY)));
						wc.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CREATEDON)));
						wc.setGroupComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_GROUPCOMPONENTID)));
						wc.setLatitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_LATITUDE)));
						wc.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_LONGITUDE)));
						wc.setStageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_STAGEID)));
						wc.setSubComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_SUBCOMPONENTID)));
						wc.setWork_CoordinatesId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_WORK_COORDINATESID)));
						wc.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKID)));
						lstWC.add(wc);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstWC;
	}
	public void updateWorkCoordinates(Work_Coordinates wc, String lastXMLid) {
		// TODO Auto-generated method stub
		long cursor;
		String[] args={String.valueOf(wc.getWork_CoordinatesId()),String.valueOf(wc.getWorkId()),String.valueOf(wc.getCoordinateId())};
		ContentValues contentValues=new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATES_XMLID,lastXMLid);
		try{
			baseDao.open();
			cursor = baseDao.Update(DBConstants.TABLE_WORK_COORDINATES, contentValues, DBConstants.COLUMN_WORK_COORDINATES_WORK_COORDINATESID +"=? and "+DBConstants.COLUMN_WORK_COORDINATES_WORKID +"=? and "+DBConstants.COLUMN_WORK_COORDINATES_COORDINATEID+"=?", args);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			baseDao.close();
		}
	}
	public WorkCoordinatePhotos getWorkCoordinatesPhotos(String username,
			String lastXMlidForWCP) {
		// TODO Auto-generated method stub
		String[] selArgs = {username,String.valueOf(lastXMlidForWCP)};
		Cursor cursor = null;
		WorkCoordinatePhotos wcp = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COORDINATESPHOTOS,DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOTAKENBY+"=? and "+DBConstants.COLUMN_WORK_COORDINATESPHOTOS_XMLID,selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					wcp = new WorkCoordinatePhotos();
					//					while(!cursor.isAfterLast()){
					wcp.setCoordinateId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_COORDINATEID)));
					wcp.setLatitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_LATITUDE)));
					wcp.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_LONGITUDE)));
					wcp.setPhotoCaption(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOCAPTION)));
					wcp.setPhotoId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOID)));
					wcp.setPhotoPath(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOPATH)));
					wcp.setPhotoTakenBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOTAKENBY)));
					wcp.setPhotoTakenOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOTAKENON)));
					wcp.setWork_CoordinatesId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_WORK_COORDINATESID)));
					wcp.setWorkState(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOSTATE)));
					wcp.setServerId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_SERVERID)));
					//						cursor.moveToNext();
					//					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return wcp;
	}
	public List<WorkCoordinatePhotos> getAllWorkCoordinatePhotos(String username) {
		// TODO Auto-generated method stub
		String[] selArgs = {username,"NULL"};
		List<WorkCoordinatePhotos> lstWCP = new ArrayList<WorkCoordinatePhotos>();
		Cursor cursor = null;
		WorkCoordinatePhotos wcp = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COORDINATESPHOTOS,DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOTAKENBY+"=? and "+DBConstants.COLUMN_WORK_COORDINATESPHOTOS_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						wcp = new WorkCoordinatePhotos();
						wcp.setCoordinateId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_COORDINATEID)));
						wcp.setLatitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_LATITUDE)));
						wcp.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_LONGITUDE)));
						wcp.setPhotoCaption(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOCAPTION)));
						wcp.setPhotoId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOID)));
						wcp.setPhotoPath(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOPATH)));
						wcp.setPhotoTakenBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOTAKENBY)));
						wcp.setPhotoTakenOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOTAKENON)));
						wcp.setWork_CoordinatesId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_WORK_COORDINATESID)));
						wcp.setWorkState(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOSTATE)));
						wcp.setServerId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_SERVERID)));
						lstWCP.add(wcp);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstWCP;
	}
	public void updateWorkCoordinatePhotos(String lastXMLId,
			WorkCoordinatePhotos wcup) {
		// TODO Auto-generated method stub
		long cursor;
		String[] args={String.valueOf(wcup.getWork_CoordinatesId()),String.valueOf(wcup.getCoordinateId()),String.valueOf(wcup.getPhotoId())};
		ContentValues contentValues=new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_XMLID,lastXMLId);
		try{
			baseDao.open();
			cursor = baseDao.Update(DBConstants.TABLE_WORK_COORDINATESPHOTOS, contentValues, DBConstants.COLUMN_WORK_COORDINATESPHOTOS_WORK_COORDINATESID +"=? and "+DBConstants.COLUMN_WORK_COORDINATESPHOTOS_COORDINATEID +"=? and "+DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOID+"=?", args);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			baseDao.close();
		}
	}

	public int getIssueIdfromWorkIssues(){

		int count = 0;
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor  = baseDao.RawQuery("select Max(IssueId) from Work_Issues ",null);
			if(cursor != null){
				int no = cursor.getCount();
				if( no > 0){

					count = cursor.getInt(0);
				}
			}

		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return count;
	}

	public String getMasterComponentDesc(){
		String compdesc="";
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.RawQuery("select ComponentDesc    from Master_Components  where  ComponentId =1", null);
			if(cursor !=null){
				int count = cursor.getCount();
				if(count > 0){
					compdesc = cursor.getString(0);
				}
			}

		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return compdesc;
	}

	public long insertIntoWorkComponentUpdationStatusWithXMLIdNULL(
			Work_Component_UpdateStatus wcu) {
		// TODO Auto-generated method stub
		long insertVal = 0;
		contentValues = new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTUPDATIONID, wcu.getWorkComponentUpdationId());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTID, wcu.getWorkComponentId());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKID, wcu.getWorkId());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_SUBWORKCOMPONENTSTAGE, wcu.getSubComponentStage());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_FROMKM, wcu.getFromKM());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_TOKM, wcu.getToKM());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_LATTITUDE, wcu.getLattitude());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_LONGITUDE, wcu.getLongitude());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSTYPE, wcu.getWorkStatusType());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORSTATUSDESCRIPTION, wcu.getWorkStatusDescription());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSASON, wcu.getWorkStatusAsOn());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSUPDATEDON, wcu.getWorkStatusUpdatedOn());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDBY, wcu.getCreatedBy());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDON, wcu.getCreatedOn());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_MODIFIEDBY, wcu.getModifiedBy());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_MODIFIEDON, wcu.getModifiedOn());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_ACTUALSTARTDATE, wcu.getActualStartDate());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_ACTUALENDDATE, wcu.getActualEndDate());
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_XMLID, "NULL");

		try{
			baseDao.open();
			insertVal = baseDao.Insert(DBConstants.TABLE_WORK_COMPONENT_UPDATESTATUS, contentValues);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			baseDao.close();
		}
		return insertVal;
	}
	public List<workissues> getAllWorkIssue(String lastXMlidForWorkIssue) {
		// TODO Auto-generated method stub
		String[] selArgs = {lastXMlidForWorkIssue};
		List<workissues> lstWI = new ArrayList<workissues>();
		Cursor cursor = null;
		workissues wi = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_ISSUES,DBConstants.COLUMN_WORK_ISSUES_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						wi = new workissues();
						wi.setIssueDescription(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_ISSUEDESCRIPTION)));
						wi.setIssueId(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_ISSUEID)));
						wi.setIssueRaisedby(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_ISSUERAISEDBY)));
						wi.setIssueRaisedon(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_ISSUERAISEDON)));
						wi.setIssueTypeId(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_ISSUETYPEID)));
						wi.setUpdationId(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_UPDATEID)));
						wi.setWorkId(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_WORKID)));
						wi.setServerId(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_SERVERID)));
						lstWI.add(wi);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstWI;
	}
	public List<workissues> getAllWorkIssue(String username, String nullVal) {
		// TODO Auto-generated method stub

		// TODO Auto-generated method stub
		String[] selArgs = {username,nullVal};
		List<workissues> lstWI = new ArrayList<workissues>();
		Cursor cursor = null;
		workissues wi = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_ISSUES,DBConstants.COLUMN_WORK_ISSUES_ISSUERAISEDBY+"=? and "+DBConstants.COLUMN_WORK_ISSUES_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						wi = new workissues();
						wi.setIssueDescription(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_ISSUEDESCRIPTION)));
						wi.setIssueId(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_ISSUEID)));
						wi.setIssueRaisedby(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_ISSUERAISEDBY)));
						wi.setIssueRaisedon(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_ISSUERAISEDON)));
						wi.setIssueTypeId(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_ISSUETYPEID)));
						wi.setUpdationId(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_UPDATEID)));
						wi.setWorkId(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_WORKID)));
						wi.setServerId(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_SERVERID)));
						lstWI.add(wi);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstWI;

	}
	public void updateWorkIssueWithUUID(workissues wi, String uuid) {
		// TODO Auto-generated method stub
		long cursor;
		String[] args={String.valueOf(wi.getWorkId()),String.valueOf(wi.getIssueId())};
		ContentValues contentValues=new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_ISSUES_XMLID,uuid);
		try{
			baseDao.open();
			cursor = baseDao.Update(DBConstants.TABLE_WORK_ISSUES, contentValues, DBConstants.COLUMN_WORK_ISSUES_WORKID +"=? and "+DBConstants.COLUMN_WORK_ISSUES_ISSUEID +"=?", args);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			baseDao.close();
		}
	}
	public void updateWorkComponentUpdateStatusForServerId(String mobileId,
			String serverId) {
		// TODO Auto-generated method stub
		long cursor;
		String[] selArgs = {mobileId};

		contentValues = new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_SERVERID, serverId);
		try{
			baseDao.open();
			cursor = baseDao.Update(DBConstants.TABLE_WORK_COMPONENT_UPDATESTATUS, contentValues, DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTUPDATIONID +"=? ", selArgs);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			baseDao.close();
		}
	}
	public void updateWorkComponentUpdateStatusPhotosForServerId(
			String mobileId, String serverId) {
		// TODO Auto-generated method stub
		long cursor;
		String[] selArgs = {mobileId};

		contentValues = new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_SERVERID, serverId);
		try{
			baseDao.open();
			cursor = baseDao.Update(DBConstants.TABLE_WORK_COMPONENT_UPDATIONS_PHOTO, contentValues, DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKCOMPONENTUPDATIONID +"=? ", selArgs);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			baseDao.close();
		}
	}
	public void updateWorkIssueForServerId(String mobileId, String serverId) {
		// TODO Auto-generated method stub
		long cursor;
		String[] selArgs = {mobileId};

		contentValues = new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_ISSUES_SERVERID, serverId);
		try{
			baseDao.open();
			cursor = baseDao.Update(DBConstants.TABLE_WORK_ISSUES, contentValues, DBConstants.COLUMN_WORK_ISSUES_UPDATEID +"=? ", selArgs);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			baseDao.close();
		}
	}
	public void updateWorkCoordinatesForServerId(String mobileId,
			String serverId) {
		// TODO Auto-generated method stub
		long cursor;
		String[] selArgs = {mobileId};

		contentValues = new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATES_SERVERID, serverId);
		try{
			baseDao.open();
			cursor = baseDao.Update(DBConstants.TABLE_WORK_COORDINATES, contentValues, DBConstants.COLUMN_WORK_COORDINATES_WORK_COORDINATESID +"=? ", selArgs);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			baseDao.close();
		}
	}
	public void updateWorkCoordinatesPhotosForServerId(String mobileId,
			String serverId) {
		// TODO Auto-generated method stub
		long cursor;
		String[] selArgs = {mobileId};

		contentValues = new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_SERVERID, serverId);
		try{
			baseDao.open();
			cursor = baseDao.Update(DBConstants.TABLE_WORK_COORDINATESPHOTOS, contentValues, DBConstants.COLUMN_WORK_COORDINATESPHOTOS_WORK_COORDINATESID +"=? ", selArgs);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			baseDao.close();
		}
	}
	public List<Work_Coordinates> getAllWork_CoordinatesForXMLID(
			String lastXMlidForWorkCoor) {
		// TODO Auto-generated method stub

		// TODO Auto-generated method stub
		String[] selArgs = {AppUserDetails.getUsername(),lastXMlidForWorkCoor};
		List<Work_Coordinates> lstWC = new ArrayList<Work_Coordinates>();
		Cursor cursor = null;
		Work_Component_Updations_Photo wcus = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COORDINATES,DBConstants.COLUMN_WORK_COORDINATES_CREATEDBY+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					wcus = new Work_Component_Updations_Photo();
					while(!cursor.isAfterLast()){
						Work_Coordinates wc = new Work_Coordinates();
						wc.setChainageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CHAINAGEID)));
						wc.setComponentGroupId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTGROUPID)));
						wc.setComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTID)));
						wc.setCoordinateId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COORDINATEID)));
						wc.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CREATEDBY)));
						wc.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CREATEDON)));
						wc.setGroupComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_GROUPCOMPONENTID)));
						wc.setLatitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_LATITUDE)));
						wc.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_LONGITUDE)));
						wc.setStageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_STAGEID)));
						wc.setSubComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_SUBCOMPONENTID)));
						wc.setWork_CoordinatesId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_WORK_COORDINATESID)));
						wc.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKID)));
						lstWC.add(wc);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstWC;

	}

	public boolean getcount(){
		Cursor cursor = null;
		Cursor cursor1 = null;
		try{
			baseDao.open();
			cursor = baseDao.RawQuery("SELECT XMLId='NULL' FROM Work_Coordinates UNION ALL SELECT XMLId ='NULL' FROM Work_CoordinatesPhotos UNION ALL  SELECT XMLId ='NULL' FROM Work_Issues UNION ALL SELECT XMLId ='NULL' FROM Work_Component_UpdateStatus UNION ALL SELECT XMLId ='NULL' FROM Work_Component_Updations_Photo", null);
			if(cursor != null){
				int count = cursor.getCount();
				if(count == 0){
					cursor1 = baseDao.RawQuery("select * from XMLSyncValidation where isSynced='N'", null);
					if(cursor1.getCount() >0){
						cursor1.close();
						return true;
					}
				}else if(count >0){
					return true;
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return false;
	}
	public String getLastXMLIdWithoutuser(String tableName, String isSync) {
		// TODO Auto-generated method stub
		String lastXMLId  = null;
		List<String> lst;
		Cursor cursor = null; 
		try{
			lst = new ArrayList<String>();
			baseDao.open();
			cursor = baseDao.RawQuery("select XMLId from XMLSyncValidation where  XMLTableName='"+tableName+"' and isSynced='"+isSync+"'", null);
			if(cursor != null){
				if(cursor.getCount()>0){
					while(!cursor.isAfterLast()){
						lastXMLId = cursor.getString(0);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return lastXMLId;
	}
	public List<Work_Component_UpdateStatus> getAllWork_Component_UpdationStatusWithoutuser(String XmlId) {
		// TODO Auto-generated method stub
		List<Work_Component_UpdateStatus> lstUpdateStatus = new ArrayList<Work_Component_UpdateStatus>();
		String[] selArgs = {XmlId};
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COMPONENT_UPDATESTATUS,DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						Work_Component_UpdateStatus wcus = new Work_Component_UpdateStatus();
						wcus.setActualEndDate(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_ACTUALENDDATE)));
						wcus.setActualStartDate(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_ACTUALSTARTDATE)));
						wcus.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDBY)));
						wcus.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDON)));
						wcus.setFromKM(Double.parseDouble(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_FROMKM))));
						wcus.setLattitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_LATTITUDE)));
						wcus.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_LONGITUDE)));
						wcus.setModifiedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_MODIFIEDBY)));
						wcus.setModifiedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_MODIFIEDON)));
						wcus.setSubComponentStage(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_SUBWORKCOMPONENTSTAGE)));
						wcus.setToKM(Double.parseDouble(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_TOKM))));
						wcus.setWorkComponentUpdationId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTUPDATIONID)));
						wcus.setWorkComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTID)));
						wcus.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKID)));
						wcus.setWorkStatusAsOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSASON)));
						wcus.setWorkStatusDescription(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORSTATUSDESCRIPTION)));
						wcus.setWorkStatusType(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSTYPE)));
						wcus.setWorkStatusUpdatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSUPDATEDON)));
						lstUpdateStatus.add(wcus);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstUpdateStatus;
	}
	public Work_Component_Updations_Photo getWorkComponentUpdationsPhotoWithoutuser(
			String lastXMlidForAppUserPhoto) {
		// TODO Auto-generated method stub
		String[] selArgs = {String.valueOf(lastXMlidForAppUserPhoto)};
		Cursor cursor = null;
		Work_Component_Updations_Photo wcus = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COMPONENT_UPDATIONS_PHOTO,DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					wcus = new Work_Component_Updations_Photo();
					//						while(!cursor.isAfterLast()){
					wcus.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_CREATEDBY)));
					wcus.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_CREATEDON)));
					wcus.setLattitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_LATTITUDE)));
					wcus.setLongtitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_LONGITUDE)));
					wcus.setModifiedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_MODIFIEDBY)));
					wcus.setModifiedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_MODIFIEDON)));
					wcus.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKID)));
					wcus.setPhoto(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTO)));
					wcus.setPhotoId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTOID)));
					wcus.setPhotoTakenOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTOTAKENON)));
					wcus.setWorkComponentUpdationId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKCOMPONENTUPDATIONID)));
					wcus.setServerId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_SERVERID)));
					//							cursor.moveToNext();
					//						}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return wcus;
	}
	public List<Work_Component_Updations_Photo> getAllWork_Component_UpdationPhotosWithoutuser() {
		// TODO Auto-generated method stub
		List<Work_Component_Updations_Photo> lstUpdateStatus = new ArrayList<Work_Component_Updations_Photo>();
		String[] selArgs = {"NULL"};
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COMPONENT_UPDATIONS_PHOTO,DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						Work_Component_Updations_Photo wcus = new Work_Component_Updations_Photo();
						wcus.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_CREATEDBY)));
						wcus.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_CREATEDON)));
						wcus.setLattitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_LATTITUDE)));
						wcus.setLongtitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_LONGITUDE)));
						wcus.setModifiedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_MODIFIEDBY)));
						wcus.setModifiedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_MODIFIEDON)));
						wcus.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKID)));
						wcus.setPhoto(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTO)));
						wcus.setPhotoId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTOID)));
						wcus.setPhotoTakenOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTOTAKENON)));
						wcus.setWorkComponentUpdationId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKCOMPONENTUPDATIONID)));
						wcus.setServerId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_SERVERID)));
						lstUpdateStatus.add(wcus);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstUpdateStatus;
	}
	public WorkCoordinatePhotos getWorkCoordinatesPhotosWithoutuser(
			String lastXMlidForWCP) {
		// TODO Auto-generated method stub
		String[] selArgs = {String.valueOf(lastXMlidForWCP)};
		Cursor cursor = null;
		WorkCoordinatePhotos wcp = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COORDINATESPHOTOS,DBConstants.COLUMN_WORK_COORDINATESPHOTOS_XMLID,selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					wcp = new WorkCoordinatePhotos();
					//					while(!cursor.isAfterLast()){
					wcp.setCoordinateId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_COORDINATEID)));
					wcp.setLatitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_LATITUDE)));
					wcp.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_LONGITUDE)));
					wcp.setPhotoCaption(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOCAPTION)));
					wcp.setPhotoId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOID)));
					wcp.setPhotoPath(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOPATH)));
					wcp.setPhotoTakenBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOTAKENBY)));
					wcp.setPhotoTakenOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOTAKENON)));
					wcp.setWork_CoordinatesId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_WORK_COORDINATESID)));
					wcp.setWorkState(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOSTATE)));
					wcp.setServerId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_SERVERID)));
					//						cursor.moveToNext();
					//					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return wcp;
	}
	public List<WorkCoordinatePhotos> getAllWorkCoordinatePhotosWithoutuser() {
		// TODO Auto-generated method stub
		String[] selArgs = {"NULL"};
		List<WorkCoordinatePhotos> lstWCP = new ArrayList<WorkCoordinatePhotos>();
		Cursor cursor = null;
		WorkCoordinatePhotos wcp = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COORDINATESPHOTOS,DBConstants.COLUMN_WORK_COORDINATESPHOTOS_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						wcp = new WorkCoordinatePhotos();
						wcp.setCoordinateId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_COORDINATEID)));
						wcp.setLatitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_LATITUDE)));
						wcp.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_LONGITUDE)));
						wcp.setPhotoCaption(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOCAPTION)));
						wcp.setPhotoId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOID)));
						wcp.setPhotoPath(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOPATH)));
						wcp.setPhotoTakenBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOTAKENBY)));
						wcp.setPhotoTakenOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOTAKENON)));
						wcp.setWork_CoordinatesId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_WORK_COORDINATESID)));
						wcp.setWorkState(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_PHOTOSTATE)));
						wcp.setServerId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATESPHOTOS_SERVERID)));
						lstWCP.add(wcp);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstWCP;
	}
	public List<Work_Coordinates> getAllWork_CoordinatesForXMLIDWithoutuser(
			String lastXMlidForWorkCoor) {
		// TODO Auto-generated method stub

		// TODO Auto-generated method stub
		String[] selArgs = {lastXMlidForWorkCoor};
		List<Work_Coordinates> lstWC = new ArrayList<Work_Coordinates>();
		Cursor cursor = null;
		Work_Component_Updations_Photo wcus = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COORDINATES,DBConstants.COLUMN_WORK_COORDINATES_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					wcus = new Work_Component_Updations_Photo();
					while(!cursor.isAfterLast()){
						Work_Coordinates wc = new Work_Coordinates();
						wc.setChainageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CHAINAGEID)));
						wc.setComponentGroupId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTGROUPID)));
						wc.setComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTID)));
						wc.setCoordinateId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COORDINATEID)));
						wc.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CREATEDBY)));
						wc.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CREATEDON)));
						wc.setGroupComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_GROUPCOMPONENTID)));
						wc.setLatitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_LATITUDE)));
						wc.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_LONGITUDE)));
						wc.setStageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_STAGEID)));
						wc.setSubComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_SUBCOMPONENTID)));
						wc.setWork_CoordinatesId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_WORK_COORDINATESID)));
						wc.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKID)));
						lstWC.add(wc);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstWC;

	}
	public List<Work_Coordinates> getAllWork_CoordinatesWithoutusername() {
		// TODO Auto-generated method stub
		String[] selArgs = {"NULL"};
		List<Work_Coordinates> lstWC = new ArrayList<Work_Coordinates>();
		Cursor cursor = null;
		Work_Component_Updations_Photo wcus = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COORDINATES,DBConstants.COLUMN_WORK_COORDINATES_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					wcus = new Work_Component_Updations_Photo();
					while(!cursor.isAfterLast()){
						Work_Coordinates wc = new Work_Coordinates();
						wc.setChainageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CHAINAGEID)));
						wc.setComponentGroupId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTGROUPID)));
						wc.setComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTID)));
						wc.setCoordinateId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COORDINATEID)));
						wc.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CREATEDBY)));
						wc.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CREATEDON)));
						wc.setGroupComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_GROUPCOMPONENTID)));
						wc.setLatitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_LATITUDE)));
						wc.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_LONGITUDE)));
						wc.setStageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_STAGEID)));
						wc.setSubComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_SUBCOMPONENTID)));
						wc.setWork_CoordinatesId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_WORK_COORDINATESID)));
						wc.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKID)));
						lstWC.add(wc);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstWC;
	}
	public List<workissues> getAllWorkIssueWithoutuser(String XmlId) {
		// TODO Auto-generated method stub

		// TODO Auto-generated method stub
		String[] selArgs = {XmlId};
		List<workissues> lstWI = new ArrayList<workissues>();
		Cursor cursor = null;
		workissues wi = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_ISSUES,DBConstants.COLUMN_WORK_ISSUES_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						wi = new workissues();
						wi.setIssueDescription(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_ISSUEDESCRIPTION)));
						wi.setIssueId(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_ISSUEID)));
						wi.setIssueRaisedby(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_ISSUERAISEDBY)));
						wi.setIssueRaisedon(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_ISSUERAISEDON)));
						wi.setIssueTypeId(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_ISSUETYPEID)));
						wi.setUpdationId(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_UPDATEID)));
						wi.setWorkId(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_WORKID)));
						wi.setServerId(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_ISSUES_SERVERID)));
						lstWI.add(wi);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstWI;

	}
	public List<Work_Component_UpdateStatus> getAllWork_Component_UpdationStatusWithoutuser() {
		// TODO Auto-generated method stub
		List<Work_Component_UpdateStatus> lstUpdateStatus = new ArrayList<Work_Component_UpdateStatus>();
		String[] selArgs = {"NULL"};
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COMPONENT_UPDATESTATUS,DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						Work_Component_UpdateStatus wcus = new Work_Component_UpdateStatus();
						wcus.setActualEndDate(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_ACTUALENDDATE)));
						wcus.setActualStartDate(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_ACTUALSTARTDATE)));
						wcus.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDBY)));
						wcus.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDON)));
						wcus.setFromKM(Double.parseDouble(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_FROMKM))));
						wcus.setLattitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_LATTITUDE)));
						wcus.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_LONGITUDE)));
						wcus.setModifiedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_MODIFIEDBY)));
						wcus.setModifiedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_MODIFIEDON)));
						wcus.setSubComponentStage(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_SUBWORKCOMPONENTSTAGE)));
						wcus.setToKM(Double.parseDouble(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_TOKM))));
						wcus.setWorkComponentUpdationId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTUPDATIONID)));
						wcus.setWorkComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTID)));
						wcus.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKID)));
						wcus.setWorkStatusAsOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSASON)));
						wcus.setWorkStatusDescription(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORSTATUSDESCRIPTION)));
						wcus.setWorkStatusType(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSTYPE)));
						wcus.setWorkStatusUpdatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSUPDATEDON)));
						lstUpdateStatus.add(wcus);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstUpdateStatus;
	}
	public void isChecked(AutoSync sync){

		long cursor;
		ContentValues values = new ContentValues();
		values.put(DBConstants.COLUMN_AUTOSYNCID, sync.getSyncId());
		values.put(DBConstants.COLUMN_ISCHECKED,sync.getIschecked());
		try{
			baseDao.open();

			cursor = baseDao.Update(DBConstants.TABLE_AUTOSYNC, values,null,null);

		}finally{
			baseDao.close();
		}


	}

	public List<String> getworkdescriptionForSynchronization(String username){
		String args[] ={username};
		Cursor cursor = null;
		List<String> lst  = new ArrayList<String>();;
		try{
			baseDao.open();
			//				select distinct(wm.WorkId) as present,* from Work_Main wm where wm.CreatedBy =? and wm.WorkId not in (select wch.WorkId from Work_Chainage wch,Work_Components wco where wch.WorkId=wco.WorkId)
			cursor  = baseDao.Query(DBConstants.TABLE_WORK_MAIN,DBConstants.COLUMN_WORK_MAIN_CREATEDBY+ " =? ",args);
			//				cursor  = baseDao.RawQuery("select distinct(wm.WorkId) as present,* from Work_Main wm where wm.CreatedBy =? and wm.WorkId in (select wch.WorkId from Work_Chainage wch,Work_Components wco where wch.WorkId=wco.WorkId)", args);
			int count = cursor.getCount();
			if(count > 0){
				while(!cursor.isAfterLast()){
					lst.add(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_MAIN_WORKNAME)));
					cursor.moveToNext();
				}	
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return lst;
	}
	public List<Work_Coordinates> getWorkCoordinatesList(String workId,
			String componentgroupid, String groupComponentId,
			String chainageId, String xmlId, Integer componentId, Integer subComponentId) {
		// TODO Auto-generated method stub

		// TODO Auto-generated method stub
		//			String[] selArgs = {workId,componentgroupid,groupComponentId,chainageId,xmlId,String.valueOf(componentId),String.valueOf(subComponentId)};
		String[] selArgs = {workId,componentgroupid,groupComponentId,chainageId,xmlId};
		List<Work_Coordinates> lstWC = new ArrayList<Work_Coordinates>();
		Cursor cursor = null;
		try{
			baseDao.open();
			//				cursor = baseDao.Query(DBConstants.TABLE_WORK_COORDINATES,DBConstants.COLUMN_WORK_COORDINATES_WORKID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_COMPONENTGROUPID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_GROUPCOMPONENTID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_CHAINAGEID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_XMLID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_COMPONENTID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_SUBCOMPONENTID+"=?",selArgs);
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COORDINATES,DBConstants.COLUMN_WORK_COORDINATES_WORKID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_COMPONENTGROUPID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_GROUPCOMPONENTID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_CHAINAGEID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						Work_Coordinates wc = new Work_Coordinates();
						wc.setChainageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CHAINAGEID)));
						wc.setComponentGroupId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTGROUPID)));
						wc.setComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTID)));
						wc.setCoordinateId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COORDINATEID)));
						wc.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CREATEDBY)));
						wc.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CREATEDON)));
						wc.setGroupComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_GROUPCOMPONENTID)));
						wc.setLatitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_LATITUDE)));
						wc.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_LONGITUDE)));
						wc.setStageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_STAGEID)));
						wc.setSubComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_SUBCOMPONENTID)));
						wc.setWork_CoordinatesId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_WORK_COORDINATESID)));
						wc.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKID)));
						lstWC.add(wc);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstWC;

	}
	public boolean isThisCoordinateForWorkidChainagePresent(String workId,
			String componentgroupid, String groupComponentId,
			String chainageId, String xmlId, Integer componentId, Integer subComponentId, Integer stageId) {
		// TODO Auto-generated method stub

		String[] selArgs = {workId,componentgroupid,groupComponentId,chainageId,xmlId,String.valueOf(componentId),String.valueOf(subComponentId),String.valueOf(stageId)};
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COORDINATES, DBConstants.COLUMN_WORK_COORDINATES_WORKID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_COMPONENTGROUPID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_GROUPCOMPONENTID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_CHAINAGEID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_XMLID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_COMPONENTID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_SUBCOMPONENTID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_STAGEID+"=?", selArgs);
			if(cursor.getCount() >0){
				return true;
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(!cursor.isClosed()){
				cursor.close();
			}
			baseDao.close();
		}
		return false;
	}
	public void updateCoordinatesForAlreadyCapturedWC(String workId,
			String componentgroupid, String groupComponentId,
			String chainageId, String xmlId, Integer componentId, Integer subComponentId, Integer stageId,Work_Coordinates wc) {
		// TODO Auto-generated method stub
		long cursor;
		String[] selArgs = {workId,componentgroupid,groupComponentId,chainageId,xmlId,String.valueOf(componentId),String.valueOf(subComponentId),String.valueOf(stageId)};

		contentValues = new ContentValues();
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATES_LATITUDE, wc.getLatitude());
		contentValues.put(DBConstants.COLUMN_WORK_COORDINATES_LONGITUDE, wc.getLongitude());
		try{
			baseDao.open();
			cursor = baseDao.Update(DBConstants.TABLE_WORK_COORDINATES,contentValues, DBConstants.COLUMN_WORK_COORDINATES_WORKID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_COMPONENTGROUPID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_GROUPCOMPONENTID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_CHAINAGEID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_XMLID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_COMPONENTID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_SUBCOMPONENTID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_STAGEID+"=?", selArgs);
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			baseDao.close();
		}

	}

	public String getIsChecked(){
		Cursor cursor = null;
		String ischecked="";
		try{
			baseDao.open();
			cursor = baseDao.RawQuery("select isChecked from AutoSync", null);
			if(cursor.getCount() >0){
				ischecked = cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_ISCHECKED));
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return ischecked;
	}
	public boolean getCountWithUsername(String Username){
		Cursor cursor = null;
		Cursor cursor1 = null;
		try{
			baseDao.open();
			cursor = baseDao.RawQuery("SELECT XMLId='NULL'  FROM Work_Coordinates where CreatedBy='"+Username+"' UNION ALL SELECT XMLId  ='NULL' FROM Work_CoordinatesPhotos where PhotoTakenBy = '"+Username+"' UNION ALL  SELECT XMLId ='NULL' FROM Work_Issues where IssueRaisedBy = '"+Username+"' UNION ALL SELECT XMLId ='NULL' FROM Work_Component_UpdateStatus where CreatedBy = '"+Username+"' UNION ALL SELECT XMLId ='NULL' FROM Work_Component_Updations_Photo   where  ModifiedBy = '"+Username+"'", null);
			if(cursor != null){
				int count = cursor.getCount();
				if(count == 0){
					cursor1 = baseDao.RawQuery("select * from XMLSyncValidation where isSynced='N' and  Appuser = '"+Username+"'", null);
					if(cursor1.getCount() >0){
						cursor1.close();
						return true;
					}
				}else if(count >0){
					return true;
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return false;
	}

	public List<String> getWorksForContinuousCoorRead(String username){
		String args[] ={username};
		Cursor cursor = null;
		List<String> lst = new ArrayList<String>();;
		try{
			lst = new ArrayList<String>();
			baseDao.open();
			//				select distinct(wm.WorkId) as present,* from Work_Main wm where wm.CreatedBy =? and wm.WorkId not in (select wch.WorkId from Work_Chainage wch,Work_Components wco where wch.WorkId=wco.WorkId)
			cursor  = baseDao.Query(DBConstants.TABLE_WORK_MAIN,DBConstants.COLUMN_WORK_MAIN_CREATEDBY+ " =? ",args);
			//				cursor  = baseDao.RawQuery("select distinct(wm.WorkId) as present,* from Work_Main wm where wm.CreatedBy =? and wm.WorkId in (select wch.WorkId from Work_Chainage wch,Work_Components wco where wch.WorkId=wco.WorkId)", args);
			int count = cursor.getCount();
			if(count > 0){
				while(!cursor.isAfterLast()){
					lst.add(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_MAIN_WORKNAME)));
					cursor.moveToNext();
				}	
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return lst;
	}

	public List<Work_Coordinates> getWorkCoordinatesList(String workId,String xmlId) {
		// TODO Auto-generated method stub

		// TODO Auto-generated method stub
		//			String[] selArgs = {workId,componentgroupid,groupComponentId,chainageId,xmlId,String.valueOf(componentId),String.valueOf(subComponentId)};
		String[] selArgs = {workId,xmlId};
		List<Work_Coordinates> lstWC = new ArrayList<Work_Coordinates>();
		Cursor cursor = null;
		try{
			baseDao.open();
			//				cursor = baseDao.Query(DBConstants.TABLE_WORK_COORDINATES,DBConstants.COLUMN_WORK_COORDINATES_WORKID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_COMPONENTGROUPID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_GROUPCOMPONENTID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_CHAINAGEID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_XMLID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_COMPONENTID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_SUBCOMPONENTID+"=?",selArgs);
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COORDINATES,DBConstants.COLUMN_WORK_COORDINATES_WORKID+"=? and "+DBConstants.COLUMN_WORK_COORDINATES_XMLID+"=?",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						Work_Coordinates wc = new Work_Coordinates();
						wc.setChainageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CHAINAGEID)));
						wc.setComponentGroupId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTGROUPID)));
						wc.setComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTID)));
						wc.setCoordinateId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COORDINATEID)));
						wc.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CREATEDBY)));
						wc.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CREATEDON)));
						wc.setGroupComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_GROUPCOMPONENTID)));
						wc.setLatitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_LATITUDE)));
						wc.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_LONGITUDE)));
						wc.setStageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_STAGEID)));
						wc.setSubComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_SUBCOMPONENTID)));
						wc.setWork_CoordinatesId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_WORK_COORDINATESID)));
						wc.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKID)));
						lstWC.add(wc);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstWC;

	}

	public List<String> getLastXMLIdList(String username, String tableName, String isSync) {
		// TODO Auto-generated method stub
		List<String> lstXmlids = new ArrayList<String>();
		String lastXMLId  = null;
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.RawQuery("select XMLId from XMLSyncValidation where Appuser='"+username+"' and XMLTableName='"+tableName+"' and isSynced='"+isSync+"'", null);
			if(cursor != null){
				if(cursor.getCount()>0){
					while(!cursor.isAfterLast()){
						lastXMLId = cursor.getString(0);
						lstXmlids.add(lastXMLId);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return lstXmlids;
	}

	public List<Work_Component_UpdateStatus> getlastestUpdates(String workId,String xmlId,int workComponentId){
		String[] args = {workId,xmlId,String.valueOf(workComponentId)};
		List<Work_Component_UpdateStatus> lst = new ArrayList<Work_Component_UpdateStatus>();
		Cursor cursor=null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COMPONENT_UPDATESTATUS, DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKID+"=? and "+DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_XMLID+"=? and "+DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTID+"=?",args);
			if(cursor != null){
				int count = cursor.getCount();
				if(count > 0){
					while(!cursor.isAfterLast()){
						Work_Component_UpdateStatus wc = new Work_Component_UpdateStatus();
						wc.setWorkStatusDescription(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORSTATUSDESCRIPTION)));
						wc.setToKM(cursor.getDouble(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_TOKM)));
						wc.setFromKM(cursor.getDouble(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_FROMKM)));
						wc.setWorkComponentUpdationId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTUPDATIONID)));
						lst.add(wc);
						cursor.moveToNext();
					}
				}

			}

		}finally{

			baseDao.close();
		}
		return lst;
	}
	public List<Work_Component_Updations_Photo> getPhotoDetails(String workUpdationId){
		String[] args = {workUpdationId};
		List<Work_Component_Updations_Photo> lstPhotoDetails = new ArrayList<Work_Component_Updations_Photo>();
		Cursor cursor=null;
		try{
			baseDao.open();
			cursor = baseDao.RawQuery("select * from Work_Component_Updations_Photo  where WorkComponentUpdationId ="+workUpdationId+"",null);
			if(cursor != null){
				int count = cursor.getCount();
				if(count > 0){
					while(!cursor.isAfterLast()){
						Work_Component_Updations_Photo wcus = new Work_Component_Updations_Photo();
						wcus.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_CREATEDBY)));
						wcus.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_CREATEDON)));
						wcus.setLattitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_LATTITUDE)));
						wcus.setLongtitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_LONGITUDE)));
						wcus.setModifiedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_MODIFIEDBY)));
						wcus.setModifiedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_MODIFIEDON)));
						wcus.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKID)));
						wcus.setPhoto(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTO)));
						wcus.setPhotoId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTOID)));
						wcus.setPhotoTakenOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_PHOTOTAKENON)));
						wcus.setWorkComponentUpdationId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_WORKCOMPONENTUPDATIONID)));
						wcus.setServerId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATIONS_PHOTO_SERVERID)));
						lstPhotoDetails.add(wcus);
						cursor.moveToNext();
					}

				}
			}
		}finally{

			baseDao.close();
		}
		return lstPhotoDetails;

	}
	
	public Work_Component_UpdateStatus getLastWCUSUpdates(
			int workComponentId, int workId, String username, String strNUll) {
		// TODO Auto-generated method stub
		Cursor cursor = null;
		Work_Component_UpdateStatus wcus = null;
		try{
			baseDao.open();
			cursor = baseDao.RawQuery("SELECT * from Work_Component_UpdateStatus where  workid = "+workId+" and CreatedBy = '"+username+"' and WorkComponentId = "+workComponentId+" and XMLId = '"+strNUll+"' order by WorkComponentUpdationId desc  limit 1", null);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						 wcus = new Work_Component_UpdateStatus();
						wcus.setActualEndDate(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_ACTUALENDDATE)));
						wcus.setActualStartDate(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_ACTUALSTARTDATE)));
						wcus.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDBY)));
						wcus.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_CREATEDON)));
						wcus.setFromKM(Double.parseDouble(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_FROMKM))));
						wcus.setLattitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_LATTITUDE)));
						wcus.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_LONGITUDE)));
						wcus.setModifiedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_MODIFIEDBY)));
						wcus.setModifiedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_MODIFIEDON)));
						wcus.setSubComponentStage(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_SUBWORKCOMPONENTSTAGE)));
						wcus.setToKM(Double.parseDouble(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_TOKM))));
						wcus.setWorkComponentUpdationId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTUPDATIONID)));
						wcus.setWorkComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKCOMPONENTID)));
						wcus.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKID)));
						wcus.setWorkStatusAsOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSASON)));
						wcus.setWorkStatusDescription(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORSTATUSDESCRIPTION)));
						wcus.setWorkStatusType(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSTYPE)));
						wcus.setWorkStatusUpdatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COMPONENT_UPDATESTATUS_WORKSTATUSUPDATEDON)));
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}
		return wcus;
	}
	
	
	public List<Work_Coordinates> getWorkCoordinatesList(String workid) {
		// TODO Auto-generated method stub
		List<Work_Coordinates> lstUpdateStatus = new ArrayList<Work_Coordinates>();
		String[] selArgs = {workid};
		Cursor cursor = null;
		try{
			baseDao.open();
			cursor = baseDao.Query(DBConstants.TABLE_WORK_COORDINATES,DBConstants.COLUMN_WORK_COORDINATES_WORKID+"=? ",selArgs);
			if(cursor != null){
				if(cursor.getCount() >0){
					while(!cursor.isAfterLast()){
						Work_Coordinates wc = new Work_Coordinates();
						wc.setChainageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CHAINAGEID)));
						wc.setComponentGroupId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTGROUPID)));
						wc.setComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COMPONENTID)));
						wc.setCoordinateId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_COORDINATEID)));
						wc.setCreatedBy(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CREATEDBY)));
						wc.setCreatedOn(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_CREATEDON)));
						wc.setGroupComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_GROUPCOMPONENTID)));
						wc.setLatitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_LATITUDE)));
						wc.setLongitude(cursor.getString(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_LONGITUDE)));
						wc.setStageId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_STAGEID)));
						wc.setSubComponentId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_SUBCOMPONENTID)));
						wc.setWork_CoordinatesId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_WORK_COORDINATESID)));
						wc.setWorkId(cursor.getInt(cursor.getColumnIndex(DBConstants.COLUMN_WORK_COORDINATES_WORKID)));
						lstUpdateStatus.add(wc);
						cursor.moveToNext();
					}
				}
			}
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		finally{
			if(cursor != null){
				if(!cursor.isClosed()){
					cursor.close();
				}
			}
			baseDao.close();
		}

		return lstUpdateStatus;
	}

}


