package com.zeal.gov.kar.pwmt.activities;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.StringWriter;
import java.nio.channels.FileChannel;
import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;
import com.zeal.gov.kar.pwmt.common.utils.AppUserDetails;
import com.zeal.gov.kar.pwmt.common.utils.CreateToastMessage;
import com.zeal.gov.kar.pwmt.daos.BaseService;
import com.zeal.gov.kar.pwmt.models.TablesWc;
import com.zeal.gov.kar.pwmt.models.Work_Component_UpdateStatus;
import com.zeal.gov.kar.pwmt.models.Work_Component_Updations_Photo;
import com.zeal.gov.kar.pwmt.models.Work_Components;
import com.zeal.gov.kar.pwmt.webservicecalls.SoapProxy;

import android.R.array;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Rect;
import android.hardware.Camera.Size;
import android.os.Bundle;
import android.os.Environment;
import android.util.Base64;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.widget.Toast;

public class UpdateExecutionTable extends Activity {

	private Spinner spnChainage;
	private TableLayout updateExecutionTableLayout;
	private String workId,componentGroupId,groupComponentId;
	private HashMap<String, Integer> hmChainageSpinner;
	private List<String> lstChainageNames;
	private HashMap<TableRow, Work_Components> hmTableRows ;
	private HashMap<TextView, Work_Components> hmTableColumns ;
	private TextView tvWorkName,tvGroupComponentName;
	private HashMap<String, String> hmdates;
	private String WorkNameDesc,GroupComponentName,Chainage;
    private int chainageId;
    int cellHeight=15,cellWidth=15,previousposition;
    String compName = null;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_updateworkexecution);


		Intent intent = getIntent();
		TablesWc tablesWc = (TablesWc) intent.getSerializableExtra("TablesWc");
		workId = intent.getStringExtra("Workrowid");
		componentGroupId = tablesWc.getComponentgroupid();
		groupComponentId = tablesWc.getGroupcomponentid();
		hmdates = new HashMap<String, String>();
		spnChainage = (Spinner) findViewById(R.id.spnChainage);
	//	AppUserDetails.setUsername("pwmt_so");
		tvWorkName = (TextView) findViewById(R.id.tvWorkName);
		tvGroupComponentName = (TextView) findViewById(R.id.tvGroupComponentName);
		updateExecutionTableLayout = (TableLayout) findViewById(R.id.updateExecutionTable);

		BaseService baseService = new BaseService(UpdateExecutionTable.this);
		WorkNameDesc = baseService.getWorkNameDesc(workId);
		tvWorkName.setText(WorkNameDesc);
		tvWorkName.setSingleLine(false);
		GroupComponentName = tablesWc.getGroupcomonentname();
		tvGroupComponentName.setText(GroupComponentName);
		bindWorksToSpinner();
		copyDatabaseToSdcard();
			//	showAlert();

		spnChainage.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {

			@Override
			public void onItemSelected(AdapterView<?> element, View arg1,
					int pos, long arg3) {
				// TODO Auto-generated method stub
				if(pos > 0){
					updateExecutionTableLayout.removeAllViewsInLayout();
					 chainageId = hmChainageSpinner.get(element.getItemAtPosition(pos).toString());
					BaseService baseService = new BaseService(UpdateExecutionTable.this);

					List<Work_Components> lstComponents = baseService.getWorkComponentsForSelectedChainage(workId,componentGroupId,groupComponentId,String.valueOf(chainageId));
					if(lstComponents.size() > 0){
						createHeaderForUpdateExecution();
						addRowsToChainageTable(lstComponents);
					}
				}else{
					updateExecutionTableLayout.removeAllViewsInLayout();
				}
			}

			@Override
			public void onNothingSelected(AdapterView<?> arg0) {
				// TODO Auto-generated method stub

			}
		});
	}
	 @Override
	    public boolean onCreateOptionsMenu(Menu menu) {
	        getMenuInflater().inflate(R.menu.tablesize, menu);
	       
				
	        return true;
	    }
	 @Override
	    public boolean onOptionsItemSelected(MenuItem item) {
	    	switch (item.getItemId()) {

	    	 case R.id.size:
	    			AlertDialog.Builder alertbox = new AlertDialog.Builder(this);
	    			LayoutInflater li = getLayoutInflater();
	    			View v = li.inflate(R.layout.changetable, null);
	    			alertbox.setView(v);

	    			final EditText edtxtHeight=(EditText)v.findViewById(R.id.sizeHeight);
	    			final EditText edtxtWidth = (EditText)v.findViewById(R.id.sizeWidth);
	    			alertbox.setMessage("Change tablesize"); // Message to be displayed

	    			alertbox.setPositiveButton("Add",new DialogInterface.OnClickListener() {

	    				public void onClick(DialogInterface dialog, int which) {
	    					// TODO Auto-generated method 
							try {
								cellHeight = Integer.parseInt(edtxtHeight
										.getText().toString());
								cellWidth = Integer.parseInt(edtxtWidth
										.getText().toString());
								previousposition = spnChainage.getSelectedItemPosition();
								
								spnChainage.setAdapter(new ArrayAdapter<String>(UpdateExecutionTable.this, android.R.layout.simple_list_item_1, lstChainageNames));
								
								spnChainage.setSelection(previousposition,true);
							} catch (Exception e) {
								// TODO: handle exception
								e.printStackTrace();
								cellHeight=15;
								cellWidth=15;
							}
	    				}

	    			});

	    			alertbox.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {


	    				public void onClick(DialogInterface dialog, int which) {
	    					// TODO Auto-generated method 	

	    				}

	    			});

	    			alertbox.show();
	    		 return true; 
	    	default:

	    		return super.onOptionsItemSelected(item);

	    	}
	    }
	@SuppressWarnings("unchecked")
	private void bindWorksToSpinner() {
		// TODO Auto-generated method stub
		hmChainageSpinner = new HashMap<String, Integer>();
		lstChainageNames = new ArrayList<String>();
		lstChainageNames.add(0,"Select Chainage");
		BaseService baseService = new BaseService(UpdateExecutionTable.this);
		HashMap<String, Object> hm = baseService.getWorksForChainageSpinner(workId,componentGroupId,groupComponentId);
		lstChainageNames.addAll((List<String>) hm.get("List"));
		hmChainageSpinner = (HashMap<String, Integer>) hm.get("Hashmap");
		spnChainage.setAdapter(new ArrayAdapter<String>(UpdateExecutionTable.this, android.R.layout.simple_list_item_1, lstChainageNames));
	}

	private void createHeaderForUpdateExecution() {
		TableRow header = new TableRow(this);
		for (int i = 0; i <= 3; i++) {
			TextView cell = new TextView(this) {
				@Override
				protected void onDraw(Canvas canvas) {
					super.onDraw(canvas);
					Rect rect = new Rect();
					Paint paint = new Paint();
					paint.setStyle(Paint.Style.STROKE);
					paint.setColor(Color.WHITE);
					paint.setStrokeWidth(2);
					getLocalVisibleRect(rect);
					canvas.drawRect(rect, paint);
				}
			};
			if (i == 0) {
				cell.setText("	  ");
			}
			if (i == 1) {
				cell.setText("From Date");
				cell.setTextColor(Color.WHITE);
			}
			if (i == 2) {
				cell.setText("To Date");
				cell.setTextColor(Color.WHITE);
			}
			if (i == 3) {
				cell.setText("View last updates");
				cell.setTextColor(Color.WHITE);
			}
			/*if (i == 3) {
				cell.setText("Location");
			}
			if (i == 4) {
				cell.setText("Cummulative completed");
			}
			if (i == 5) {
				cell.setText("In progress");
			}
			if (i == 6) {
				cell.setText("Untackled");
			}*/
			cell.setPadding(cellWidth,cellHeight,cellWidth,cellHeight);
			cell.setBackgroundColor(Color.rgb(0, 0, 0));
			header.addView(cell);
		}
		updateExecutionTableLayout.addView(header);
	}

	private void addRowsToChainageTable(List<Work_Components> lstComponents) {
		DateFormat dateFormat = android.text.format.DateFormat.getDateFormat(UpdateExecutionTable.this);
		hmTableRows = new HashMap<TableRow, Work_Components>();
		hmTableColumns = new HashMap<TextView, Work_Components>();
		List<String> lststr = new ArrayList<String>();
		BaseService baseService = new BaseService(UpdateExecutionTable.this);
		HashMap<Integer, String> hmComponents = baseService.getMasterComponents();
		Iterator<Work_Components> itr = lstComponents.iterator();
		while(itr.hasNext()){
			Work_Components wc = itr.next();
			TableRow trForWorkChainage = new TableRow(UpdateExecutionTable.this);
			
			for (int i = 0; i <= 3; i++) {
               
				TextView textView = new TextView(UpdateExecutionTable.this) {
					@Override
					protected void onDraw(Canvas canvas) {
						super.onDraw(canvas);
						Rect rect = new Rect();
						Paint paint = new Paint();
						paint.setStyle(Paint.Style.STROKE);
						paint.setColor(Color.WHITE);
						paint.setStrokeWidth(2);
						getLocalVisibleRect(rect);
						canvas.drawRect(rect, paint);
					}
				};
				if (i == 0) {
					//
					//textView.setText(hmComponents.get(wc.getComponentId()));
					
					if(wc.getComponentId()==3){
						compName = baseService.getcompentname(wc.getComponentId(), wc.getSubComponentId())+"("+wc.getLocationKM()+")";
						
					   
					textView.setText(compName);
					}else if(wc.getComponentId() == 1){
						compName = baseService.getMasterComponentDesc();
						
							 textView.setText(compName);	
						
					
					}
					else{
						compName = baseService.getcompentname(wc.getComponentId(), wc.getSubComponentId());
						
						textView.setText(compName);
						}
					
					
				}

				if (i == 1) {
					textView.setText(wc.getFromDate().isEmpty()?"":wc.getFromDate().substring(0,10));
				}

				if (i == 2) {
					textView.setText(wc.getToDate().isEmpty()?"":wc.getToDate().substring(0,10));
				}
				if (i == 3) {
					textView.setText("...");
					hmTableColumns.put(textView, wc);
					textView.setOnClickListener(new View.OnClickListener() {
						
						@Override
						public void onClick(View v) {
							// TODO Auto-generated method stub
							Work_Components wcHistory = hmTableColumns.get((TextView)v);
							BaseService serv = new BaseService(UpdateExecutionTable.this);
							Work_Component_UpdateStatus wcus = serv.getLastWCUSUpdates(wcHistory.getWorkComponentId(),wcHistory.getWorkId(),AppUserDetails.getUsername(),"NULL");
							if(wcus !=null){
								showHistoryAlert(wcus);
							}else{
								Toast.makeText(UpdateExecutionTable.this,"No last updates available",Toast.LENGTH_SHORT).show();
//								CreateToastMessage.showToastMessage(UpdateExecutionTable.this, "No last updates available");
							}
						}
					});
				}

				/*if (i == 3) {
					textView.setText(String.valueOf(wc.getLocationKM()));
				}

				if (i == 4) {
					textView.setText("");
				}

				if (i == 5) {
					textView.setText("");
				}

				if (i == 6) {
					textView.setText("");
				}
*/
				textView.setPadding(cellWidth,cellHeight,cellWidth,cellHeight);
				textView.setTextColor(Color.BLACK);
				trForWorkChainage.addView(textView);

			}
			if(!lststr.contains(compName)){
			hmTableRows.put(trForWorkChainage, wc);
			
				   lststr.add(compName);
			
			updateExecutionTableLayout.addView(trForWorkChainage);
			}
			trForWorkChainage.setOnClickListener(new View.OnClickListener() {

				@Override
				public void onClick(View v) {
					// TODO Auto-generated method stub

					TableRow row = (TableRow)v;
					Work_Components selectedComponent = hmTableRows.get((TableRow)v);
					BaseService baseService = new BaseService(UpdateExecutionTable.this);
					hmdates = baseService.getto(Integer.parseInt(workId), selectedComponent.getComponentGroupId(), chainageId );
					System.out.println(hmdates.get("fromdistance"));
					System.out.println(hmdates.get("Todistance"));
					Intent intent = new Intent(UpdateExecutionTable.this, WorkUpdatingActivity.class);
					intent.putExtra("Work_Components", selectedComponent);
					intent.putExtra("WorkNameDesc", WorkNameDesc);
					intent.putExtra("GroupComponentName", GroupComponentName);
					intent.putExtra("ChainageName", spnChainage.getSelectedItem().toString());
				    intent.putExtra("hashmap", hmdates);
				    intent.putExtra("WorkDesc", ((TextView)row.getChildAt(0)).getText().toString());
					startActivity(intent);
				}
			});
		}

	}

	protected void showHistoryAlert(Work_Component_UpdateStatus wcus) {
		// TODO Auto-generated method stub
		AlertDialog.Builder builder = new AlertDialog.Builder(UpdateExecutionTable.this);
		builder.setTitle("Last updated");
		builder.setMessage("Last updated values:\n "+"From KM:"+wcus.getFromKM()+"\n"+"To km:"+wcus.getToKM()+"\n"+"Status:"+wcus.getWorkStatusDescription());
		builder.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub
				dialog.dismiss();
			}
		});
		builder.create();
		builder.show();
	}
	private void showAlert()
	{
		AlertDialog.Builder alertbox = new AlertDialog.Builder(this);
		LayoutInflater li = getLayoutInflater();
		View v = li.inflate(R.layout.backupscreen, null);
		alertbox.setView(v);

		final EditText edtxtPassword=(EditText)v.findViewById(R.id.buckUpPassword);
		alertbox.setMessage("Enter Password"); // Message to be displayed

		alertbox.setPositiveButton("Add",new DialogInterface.OnClickListener() {

			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method 

				if(edtxtPassword.getText().toString().equalsIgnoreCase("gescom321"))
				{
					copyDatabaseToPhone();
					Toast.makeText(UpdateExecutionTable.this, "Application Database changed.",Toast.LENGTH_LONG).show();
				}
				else
				{
					Toast.makeText(UpdateExecutionTable.this, "Access Denied !! ",Toast.LENGTH_LONG).show();

				}

			}

		});

		alertbox.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {


			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method 	

			}

		});

		alertbox.show();
	}

	private void copyDatabaseToPhone() {
		try {
			File data = Environment.getExternalStorageDirectory();
			File sd = Environment.getDataDirectory();

			if (data.canWrite()) {
				String currentDBPath = "//backup//testing//pwmt.db";
				String backupDBPath = "//data//com.zeal.gov.kar.pwmt.activities//databases//pwmt.db";
				File currentDB = new File(data, currentDBPath);
				File backupDB = new File(sd, backupDBPath);

				if (currentDB.exists()) {
					FileChannel src = new FileInputStream(currentDB)
					.getChannel();
					FileChannel dst = new FileOutputStream(backupDB)
					.getChannel();
					dst.transferFrom(src, 0, src.size());
					src.close();
					dst.close();
				}
			}
		} catch (Exception e) {
		}
	}

	private void copyDatabaseToSdcard() {
		try {
			File sd = Environment.getExternalStorageDirectory();
			File data = Environment.getDataDirectory();
//			Toast.makeText(UpdateExecutionTable.this, "Latest Db Copied to sddcard", Toast.LENGTH_LONG).show();
			if (sd.canWrite()) {
				String currentDBPath = "//data//com.zeal.gov.kar.pwmt.activities//databases//pwmt.db";
				String backupDBPath = "//testingbackup//pwmt.db";
				File currentDB = new File(data, currentDBPath);
				File backupDB = new File(sd, backupDBPath);

				if (currentDB.exists()) {
					FileChannel src = new FileInputStream(currentDB)
					.getChannel();
					FileChannel dst = new FileOutputStream(backupDB)
					.getChannel();
					dst.transferFrom(src, 0, src.size());
					src.close();
					dst.close();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}


	private void copyXmlToSdcard() {
		try {
			File sd = Environment.getExternalStorageDirectory();
			File data = Environment.getDataDirectory();

			if (sd.canWrite()) {
				String currentDBPath = "//data//com.zeal.gov.kar.pwmt.activities//files//Work_Component_Updations_Photo.xml";
				String backupDBPath = "Work_Component_Updations_Photo.xml";
				File currentDB = new File(data, currentDBPath);
				File backupDB = new File(sd, backupDBPath);

				if (currentDB.exists()) {
					FileChannel src = new FileInputStream(currentDB)
					.getChannel();
					FileChannel dst = new FileOutputStream(backupDB)
					.getChannel();
					dst.transferFrom(src, 0, src.size());
					src.close();
					dst.close();
				}
			}
		} catch (Exception e) {

			e.printStackTrace();
		}
	}
}
