package com.zeal.gov.kar.pwmt.activities;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.channels.FileChannel;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.UUID;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Environment;
import android.preference.PreferenceManager;
import android.util.Base64;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

import com.zeal.gov.kar.pwmt.common.utils.AppUserDetails;
import com.zeal.gov.kar.pwmt.common.utils.ConnectionManager;
import com.zeal.gov.kar.pwmt.common.utils.CreateToastMessage;
import com.zeal.gov.kar.pwmt.daos.BaseService;
import com.zeal.gov.kar.pwmt.models.ServerUploadResponse;
import com.zeal.gov.kar.pwmt.models.WorkCoordinatePhotos;
import com.zeal.gov.kar.pwmt.models.Work_Component_UpdateStatus;
import com.zeal.gov.kar.pwmt.models.Work_Component_Updations_Photo;
import com.zeal.gov.kar.pwmt.models.Work_Coordinates;
import com.zeal.gov.kar.pwmt.models.workissues;
import com.zeal.gov.kar.pwmt.parser.SoapParser;
import com.zeal.gov.kar.pwmt.webservicecalls.SoapProxy;

public class UsermenuActivity extends Activity{
	private Button synchronization,workSurvey,btnUpload,btnCoorImage,btnCoorRead;
	SoapProxy proxy;
	SoapParser parser;
	String ischeck;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_usermenu);
		proxy=new SoapProxy(this);
		parser=new SoapParser(this);
		copyDatabaseToSdcard();
		

		synchronization = (Button) findViewById(R.id.syncronization);
		btnUpload = (Button) findViewById(R.id.btnUpload);
		workSurvey = (Button) findViewById(R.id.workSurvey);
		btnCoorImage = (Button) findViewById(R.id.btnCoorImage);
		btnCoorRead = (Button) findViewById(R.id.btnCoorRead);
		BaseService baseService = new BaseService(UsermenuActivity.this);
		ischeck = baseService.getIsChecked();
		//if(ischeck.equalsIgnoreCase("Y")){
		btnCoorRead.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				Intent intent = new Intent(UsermenuActivity.this, WorkCoordinatesSelectProjectActivity.class);
				startActivity(intent);
			}
		});

		btnCoorImage.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				Intent intent = new Intent(UsermenuActivity.this, WorkCoordinateStage1Activity.class);
				startActivity(intent);
			}
		});

		synchronization.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				if (ConnectionManager.isInternetAvailable(getApplicationContext())) {
					new Syncronization().execute();
				}else{
					CreateToastMessage.showToastMessage(UsermenuActivity.this, "Internet connection not available");
				}


			}
		});

		btnUpload.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				AlertDialog.Builder alertDialog = new AlertDialog.Builder(UsermenuActivity.this);
				alertDialog.setTitle("Alert Dialog");
				alertDialog.setMessage("Do u want to upload work ?");
				alertDialog.setPositiveButton("YES", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog,int n) {
						// Toast.makeText(getApplicationContext(), "You clicked on YES", Toast.LENGTH_SHORT).show();
					//	new UploadWorks().execute();
						SharedPreferences preferences = PreferenceManager.getDefaultSharedPreferences(UsermenuActivity.this);
						if(preferences.getBoolean("Photos",false) == false){
							Toast.makeText(UsermenuActivity.this, " Hi", Toast.LENGTH_LONG).show();
						}
					}
				});
				alertDialog.setNegativeButton("NO", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int n) {
						//Toast.makeText(getApplicationContext(), "You clicked on NO", Toast.LENGTH_SHORT).show();
						dialog.cancel();
					}
				});
				alertDialog.show(); 
			}
		});

		workSurvey.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				Intent intent = new Intent(UsermenuActivity.this, ViewWorkExecutionActivity.class);
				startActivity(intent);
			}
		});


	}
	
	
	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		SharedPreferences sharedPrefs = PreferenceManager.getDefaultSharedPreferences(this);
		 
		 if(sharedPrefs.getBoolean("prefSendReport", false) == true){
			
		 BaseService baseSer = new BaseService(UsermenuActivity.this);
			if(baseSer.getCountWithUsername(AppUserDetails.getUsername())){
			AlertDialog.Builder alertDialog = new AlertDialog.Builder(UsermenuActivity.this);
			alertDialog.setTitle("Alert Dialog");
			alertDialog.setMessage("There are some data present to upload, Do you want to upload them now..?");
			alertDialog.setPositiveButton("YES", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog,int n) {
					// Toast.makeText(getApplicationContext(), "You clicked on YES", Toast.LENGTH_SHORT).show();
				//	new UploadWorks().execute();
					
				}
			});
			alertDialog.setNegativeButton("NO", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int n) {
					//Toast.makeText(getApplicationContext(), "You clicked on NO", Toast.LENGTH_SHORT).show();
					dialog.cancel();
				}
			});
			alertDialog.create();
			alertDialog.show(); 
		}
		}
	}
	 @Override
	    public boolean onCreateOptionsMenu(Menu menu) {
	        getMenuInflater().inflate(R.menu.user_menu, menu);
	        BaseService baseService = new BaseService(UsermenuActivity.this);
				String ischeck = baseService.getIsChecked();
				/*if(ischeck.equals("Y")){
					menu.findItem(R.id.autoupload).setChecked(true);
				}else{
					menu.findItem(R.id.autoupload).setChecked(false);	
				}*/
				
	        return true;
	    }
	 
	    @Override
	    public boolean onOptionsItemSelected(MenuItem item) {
	    	switch (item.getItemId()) {

	    	 case R.id.setting:
	    		 BaseService baseService = new BaseService(UsermenuActivity.this);
	    		 Intent intent = new Intent(UsermenuActivity.this,PreferenActivity.class);
	    		 
	    		
	    		 startActivity(intent);

	    		 
//	    		 if (item.isChecked()) item.setChecked(false);
//	             else item.setChecked(true);
	    		 
//	             Toast.makeText(this, "Autosync", Toast.LENGTH_SHORT).show();
	             return true; 


	    	/*case R.id.autoupload:
	    		BaseService baseService = new BaseService(UsermenuActivity.this);

	    		if (item.isChecked())
	    		{
	    			try {
	    				synchronized(item){
	    					//	 item.wait(2000);
	    					item.setChecked(false).wait(2000);

	    				}
	    			} catch (InterruptedException e) {
	    				// TODO Auto-generated catch block
	    				e.printStackTrace();
	    			}
	    			AutoSync sync = new AutoSync();
	    			sync.setSyncId(1);
	    			sync.setIschecked("N");
	    			baseService.isChecked(sync);
	    	
	    		}
	    		else{
	    			try {
	    				synchronized(item){

	    					// item.wait(2000);
	    					item.setChecked(true).wait(2000);
	    				}
	    			} catch (InterruptedException e) {
	    				// TODO Auto-generated catch block
	    				e.printStackTrace();
	    			}
	    			AutoSync sync = new AutoSync();
	    			sync.setSyncId(1);
	    			sync.setIschecked("Y");
	    			baseService.isChecked(sync);
	    		}

	    		return true; */
	    	default:

	    		return super.onOptionsItemSelected(item);

	    	}
	    }


	@Override
	public void onBackPressed() {
		// TODO Auto-generated method stub
		super.onBackPressed();

		Intent intent = new Intent(UsermenuActivity.this, LoginActivity.class);
		intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
		startActivity(intent);
		finish();
	}

	private class UploadWorks extends AsyncTask<String, Void, String>{



		private final ProgressDialog dialog = new ProgressDialog(
				UsermenuActivity.this);

		@Override
		protected void onPreExecute() {
			this.dialog.setMessage("Uploading");
			this.dialog.setCancelable(false);
			this.dialog.setCanceledOnTouchOutside(false);
			this.dialog.show();
		}

		@Override
		protected String doInBackground(String... arg0) {
			String response = new String();
			//Database Creation
			boolean noData = false,connectionProblem = false;
			String workStatus = "Work Uploaded ";
			BaseService bService = new BaseService(UsermenuActivity.this);
			SoapProxy soap =  new SoapProxy(UsermenuActivity.this);
			SoapParser parser = new SoapParser(UsermenuActivity.this);
			String lastXMlidForAppUser = bService.getLastXMLId(AppUserDetails.getUsername(),"Work_Component_UpdateStatus","N");
			if(lastXMlidForAppUser != null){
				noData = true;
				String resVal = soap.checkForXmlSync(lastXMlidForAppUser);
				if(resVal.equalsIgnoreCase("N")){
					String Work_Component_UpdateStatusxml = createWorkComponentUpdationXMl(lastXMlidForAppUser);
					if(Work_Component_UpdateStatusxml != null){
						List<Work_Component_UpdateStatus> lst = bService.getAllWork_Component_UpdationStatus(lastXMlidForAppUser);
						String wcuRes = soap.uploadWorkToServer(lst.get(0).getCreatedBy(), "Work_Component_UpdateStatus", Work_Component_UpdateStatusxml,lastXMlidForAppUser);
						if(!wcuRes.equals("Failure")){
							if(!wcuRes.equals("N")){
								ServerUploadResponse sur = parser.parseServerUploadResponse(wcuRes,"Work_Component_UpdateStatus");
								String status = sur.getStatus();
								if(status != null){
									bService.updateXMLSync(status,lastXMlidForAppUser);
									if(status.equalsIgnoreCase("Y")){
										HashMap<Integer, Integer> hmRes = sur.getHmIds();
										if(hmRes != null){
											Iterator<Entry<Integer, Integer>> itrRes = hmRes.entrySet().iterator();
											while (itrRes.hasNext()) {
												@SuppressWarnings("rawtypes")
												Map.Entry pairs = (Map.Entry) itrRes.next();
												String mobileId = String.valueOf(pairs.getKey());
												String serverId = String.valueOf(pairs.getValue());
												bService.updateWorkComponentUpdateStatusForServerId(mobileId,serverId);
												bService.updateWorkComponentUpdateStatusPhotosForServerId(mobileId,serverId);
												bService.updateWorkIssueForServerId(mobileId,serverId);
											}
										}
									}
								}
							}else{
								bService.updateXMLSync(wcuRes,lastXMlidForAppUser);
								workStatus = workStatus +",Failed to uploaded Work Update Status";
							}
						}
					}
				}else{
					if(!resVal.equalsIgnoreCase("Failure")){
						
						
						ServerUploadResponse sur = parser.parseServerUploadResponse(resVal,"Work_Component_UpdateStatus");
						String status = sur.getStatus();
						if(status != null){
							bService.updateXMLSync(status,lastXMlidForAppUser);
							if(status.equalsIgnoreCase("Y")){
								HashMap<Integer, Integer> hmRes = sur.getHmIds();
								if(hmRes != null){
									Iterator<Entry<Integer, Integer>> itrRes = hmRes.entrySet().iterator();
									while (itrRes.hasNext()) {
										@SuppressWarnings("rawtypes")
										Map.Entry pairs = (Map.Entry) itrRes.next();
										String mobileId = String.valueOf(pairs.getKey());
										String serverId = String.valueOf(pairs.getValue());
										bService.updateWorkComponentUpdateStatusForServerId(mobileId,serverId);
										bService.updateWorkComponentUpdateStatusPhotosForServerId(mobileId,serverId);
										bService.updateWorkIssueForServerId(mobileId,serverId);
									}
								}
							}else if(status.equalsIgnoreCase("N")){
								bService.updateXMLSync(status,lastXMlidForAppUser);
							}
						}
					
						
					}
				}
			}
			List<Work_Component_UpdateStatus> lst = bService.getAllWork_Component_UpdationStatus();
			String Work_Component_UpdateStatusxml = createWorkComponentUpdationXMl();
			if(Work_Component_UpdateStatusxml != null){
				noData = true;
				String lastXMlidForAppUserWCUS = bService.getLastXMLId(AppUserDetails.getUsername(),"Work_Component_UpdateStatus","N");
				String wcuRes = soap.uploadWorkToServer(lst.get(0).getCreatedBy(), "Work_Component_UpdateStatus", Work_Component_UpdateStatusxml,lastXMlidForAppUserWCUS);
				if(!wcuRes.equals("Failure")){
					//					bService.updateXMLSync(wcuRes,lastXMlidForAppUserWCUS);
					if(!wcuRes.equals("N")){
						ServerUploadResponse sur = parser.parseServerUploadResponse(wcuRes,"Work_Component_UpdateStatus");
						String status = sur.getStatus();
						if(status != null){
							bService.updateXMLSync(status,lastXMlidForAppUserWCUS);
							if(status.equalsIgnoreCase("Y")){
								HashMap<Integer, Integer> hmRes = sur.getHmIds();
								if(hmRes != null){
									Iterator<Entry<Integer, Integer>> itrRes = hmRes.entrySet().iterator();
									while (itrRes.hasNext()) {
										@SuppressWarnings("rawtypes")
										Map.Entry pairs = (Map.Entry) itrRes.next();
										String mobileId = String.valueOf(pairs.getKey());
										String serverId = String.valueOf(pairs.getValue());
										bService.updateWorkComponentUpdateStatusForServerId(mobileId,serverId);
										bService.updateWorkComponentUpdateStatusPhotosForServerId(mobileId,serverId);
										bService.updateWorkIssueForServerId(mobileId,serverId);
									}
								}
							}
						}
					}else{
						bService.updateXMLSync(wcuRes,lastXMlidForAppUserWCUS);
						if(!workStatus.contains("Failed to uploaded Work Update Status"))
						{
							workStatus = workStatus +",Failed to uploaded Work Update Status";
						}
					}

				}
			}
 SharedPreferences preferences = PreferenceManager.getDefaultSharedPreferences(UsermenuActivity.this);
 if(preferences.getBoolean("Photos", false) == false){
			List<String> lstXmlPhotoids = bService.getLastXMLIdList(AppUserDetails.getUsername(),"Work_Component_Updations_Photo","N");
			for(String lastXMlidForAppUserPhoto :lstXmlPhotoids){
//				String lastXMlidForAppUserPhoto = bService.getLastXMLIdList(AppUserDetails.getUsername(),"Work_Component_Updations_Photo","N");
				if(lastXMlidForAppUserPhoto != null){
					noData = true;
					String resVal = soap.checkForXmlSync(lastXMlidForAppUserPhoto);
					if(resVal.equalsIgnoreCase("N")){
						//					String Work_Component_UpdateStatusxmlPhoto = createWorkComponentUpdationPhotoXMl(lastXMlidForAppUser);
						Work_Component_Updations_Photo work_Component_UpdateStatusxmlPhoto = bService.getWorkComponentUpdationsPhoto(AppUserDetails.getUsername(),lastXMlidForAppUserPhoto);
						if(work_Component_UpdateStatusxmlPhoto != null){
							String Work_Component_UpdateStatusxmlPhoto = createWorkComponentUpdationPhotoXMl(work_Component_UpdateStatusxmlPhoto);
							if(Work_Component_UpdateStatusxmlPhoto != null){
								String wcuRes = soap.uploadWorkToServer(work_Component_UpdateStatusxmlPhoto.getCreatedBy(), "Work_Component_Updations_Photo", Work_Component_UpdateStatusxmlPhoto,lastXMlidForAppUserPhoto);
								if(!wcuRes.equals("Failure")){
									bService.updateXMLSync(wcuRes,lastXMlidForAppUserPhoto);
								}
							}
						}
					}else{
						if(!resVal.equalsIgnoreCase("Failure")){
							bService.updateXMLSync(resVal,lastXMlidForAppUserPhoto);
						}
					}
				}
			}

			List<Work_Component_Updations_Photo> lstWCUP = bService.getAllWork_Component_UpdationPhotos(AppUserDetails.getUsername());
			Iterator<Work_Component_Updations_Photo> itr = lstWCUP.iterator();
			while(itr.hasNext()){
				noData = true;
				Work_Component_Updations_Photo wcup = itr.next();
//				int serverId = wcup.getServerId();
				if(!String.valueOf(wcup.getServerId()).equals("null")){
					String uuid = UUID.randomUUID().toString().replaceAll("-", "");
					bService.insertIntoXMLSync(uuid,"Work_Component_Updations_Photo",AppUserDetails.getUsername());
					bService.updateWorkComponentUpdationsPhoto(uuid,wcup); 
					String Work_Component_Updations_Photoxml = createWorkComponentUpdationPhotoXMl(wcup,uuid);
					String wcuRes = soap.uploadWorkToServer(wcup.getCreatedBy(), "Work_Component_Updations_Photo", Work_Component_Updations_Photoxml,uuid);
					if(!wcuRes.equals("Failure")){
						bService.updateXMLSync(wcuRes,uuid);
					}
				}
			}
 }
			String lastXMlidForWorkCoor = bService.getLastXMLId(AppUserDetails.getUsername(),"Work_Coordinates","N");
			if(lastXMlidForWorkCoor != null){
				noData = true;
				String resVal = soap.checkForXmlSync(lastXMlidForWorkCoor);
				if(resVal.equalsIgnoreCase("N")){
					List<Work_Coordinates> lstWC = bService.getAllWork_CoordinatesForXMLID(lastXMlidForWorkCoor);
					String Work_Coordinatesxml = createWorkCoordinatesLastXMlID(lastXMlidForWorkCoor);
					if(Work_Coordinatesxml != null){
						String wcuRes = soap.uploadWorkToServer(lstWC.get(0).getCreatedBy(), "Work_Coordinates", Work_Coordinatesxml,lastXMlidForWorkCoor);
						/*if(!wcuRes.equals("Failure")){
							bService.updateXMLSync(wcuRes,lastXMlidForWorkCoor);
						}*/
						if(!wcuRes.equals("Failure")){
							if(!wcuRes.equals("N")){
								ServerUploadResponse sur = parser.parseServerUploadResponse(wcuRes,"Work_Coordinates");
								String status = sur.getStatus();
								if(status != null){
									bService.updateXMLSync(status,lastXMlidForWorkCoor);
									if(status.equalsIgnoreCase("Y")){
										HashMap<Integer, Integer> hmRes = sur.getHmIds();
										if(hmRes != null){
											Iterator<Entry<Integer, Integer>> itrRes = hmRes.entrySet().iterator();
											while (itrRes.hasNext()) {
												@SuppressWarnings("rawtypes")
												Map.Entry pairs = (Map.Entry) itrRes.next();
												String mobileId = String.valueOf(pairs.getKey());
												String serverId = String.valueOf(pairs.getValue());
												bService.updateWorkCoordinatesForServerId(mobileId,serverId);
												bService.updateWorkCoordinatesPhotosForServerId(mobileId,serverId);
											}
										}
									}
								}
							}else{
								bService.updateXMLSync(wcuRes,lastXMlidForWorkCoor);
								workStatus = workStatus + ",Work_Coordinates";
							}
						}
					}
				}else{
					if(!resVal.equalsIgnoreCase("Failure")){
						
						ServerUploadResponse sur = parser.parseServerUploadResponse(resVal,"Work_Coordinates");
						String status = sur.getStatus();
						if(status != null){
							bService.updateXMLSync(status,lastXMlidForWorkCoor);
							if(status.equalsIgnoreCase("Y")){
								HashMap<Integer, Integer> hmRes = sur.getHmIds();
								if(hmRes != null){
									Iterator<Entry<Integer, Integer>> itrRes = hmRes.entrySet().iterator();
									while (itrRes.hasNext()) {
										@SuppressWarnings("rawtypes")
										Map.Entry pairs = (Map.Entry) itrRes.next();
										String mobileId = String.valueOf(pairs.getKey());
										String serverId = String.valueOf(pairs.getValue());
										bService.updateWorkCoordinatesForServerId(mobileId,serverId);
										bService.updateWorkCoordinatesPhotosForServerId(mobileId,serverId);
									}
								}
							}else if(status.equalsIgnoreCase("N")){
								bService.updateXMLSync(status,lastXMlidForWorkCoor);
							}
						}
					
					}
				}
			}

			List<Work_Coordinates> lstWC = bService.getAllWork_Coordinates(AppUserDetails.getUsername());
			String Work_Coordinatexml = createWorkCoordinatesXMl();
			if(Work_Coordinatexml != null){
				noData = true;
				String lastXMlidForAppUserWC = bService.getLastXMLId(AppUserDetails.getUsername(),"Work_Coordinates","N");
				String wcuRes = soap.uploadWorkToServer(lstWC.get(0).getCreatedBy(), "Work_Coordinates", Work_Coordinatexml,lastXMlidForAppUserWC);
				/*if(!wcuRes.equals("Failure")){
					bService.updateXMLSync(wcuRes,lastXMlidForAppUserWC);
				}*/
				if(!wcuRes.equals("Failure")){
					if(!wcuRes.equals("N")){
						ServerUploadResponse sur = parser.parseServerUploadResponse(wcuRes,"Work_Coordinates");
						String status = sur.getStatus();
						if(status != null){
							bService.updateXMLSync(status,lastXMlidForAppUserWC);
							if(status.equalsIgnoreCase("Y")){
								HashMap<Integer, Integer> hmRes = sur.getHmIds();
								if(hmRes != null){
									Iterator<Entry<Integer, Integer>> itrRes = hmRes.entrySet().iterator();
									while (itrRes.hasNext()) {
										@SuppressWarnings("rawtypes")
										Map.Entry pairs = (Map.Entry) itrRes.next();
										String mobileId = String.valueOf(pairs.getKey());
										String serverId = String.valueOf(pairs.getValue());
										bService.updateWorkCoordinatesForServerId(mobileId,serverId);
										bService.updateWorkCoordinatesPhotosForServerId(mobileId,serverId);
									}
								}
							}
						}
					}else{
						bService.updateXMLSync(wcuRes,lastXMlidForAppUserWC);
						if(!workStatus.contains("Work_Coordinates")){
							workStatus = workStatus +",Work_Coordinates";
						}
					}
				}
				
			}

			String lastXMlidForWCP = bService.getLastXMLId(AppUserDetails.getUsername(),"Work_CoordinatesPhotos","N");
			if(lastXMlidForWCP != null){
				noData = true;
				String resVal = soap.checkForXmlSync(lastXMlidForWCP);
				if(resVal.equalsIgnoreCase("N")){
					//					String Work_Component_UpdateStatusxmlPhoto = createWorkComponentUpdationPhotoXMl(lastXMlidForAppUser);
					WorkCoordinatePhotos coordinatePhotos = bService.getWorkCoordinatesPhotos(AppUserDetails.getUsername(),lastXMlidForWCP);
					if(coordinatePhotos != null){
						String workCoordinatePhotosxml = createCoordinatePhotosXMl(coordinatePhotos);
						if(workCoordinatePhotosxml != null){
							String wcuRes = soap.uploadWorkToServer(coordinatePhotos.getPhotoTakenBy(), "Work_CoordinatesPhotos", workCoordinatePhotosxml,lastXMlidForWCP);
							if(!wcuRes.equals("Failure")){
								bService.updateXMLSync(wcuRes,lastXMlidForWCP);
							}
						}
					}
				}else{
					if(resVal.equalsIgnoreCase("Failure")){
						bService.updateXMLSync(resVal,lastXMlidForWCP);
					}
				}
			}

			List<WorkCoordinatePhotos> lstWCP = bService.getAllWorkCoordinatePhotos(AppUserDetails.getUsername());
			Iterator<WorkCoordinatePhotos> itrWCP = lstWCP.iterator();
			while(itrWCP.hasNext()){
				noData = true;
				WorkCoordinatePhotos wcup = itrWCP.next();
				/*	int lastXMLId = bService.getLastXMLId();
				++lastXMLId;*/
				String uuid = UUID.randomUUID().toString().replaceAll("-", "");
				bService.insertIntoXMLSync(uuid,"Work_CoordinatesPhotos",AppUserDetails.getUsername());
				bService.updateWorkCoordinatePhotos(uuid,wcup); 
				String WorkCoordinatePhotosxml = createWorkCoordinatePhotosxmlXMl(wcup,uuid);
				String wcuRes = soap.uploadWorkToServer(wcup.getPhotoTakenBy(), "Work_CoordinatesPhotos", WorkCoordinatePhotosxml,uuid);
				if(!wcuRes.equals("Failure")){
					bService.updateXMLSync(wcuRes,uuid);
				}
			}

			////////////////////////////

			String lastXMlidForWorkIssue = bService.getLastXMLId(AppUserDetails.getUsername(),"Work_Issues","N");
			if(lastXMlidForWorkIssue != null){
				noData = true;
				String resVal = soap.checkForXmlSync(lastXMlidForWorkIssue);
				if(resVal.equalsIgnoreCase("N")){
					List<workissues> lstWI = bService.getAllWorkIssue(lastXMlidForWorkIssue);
					String Work_IssueXml = createWorkIssueXMl(lastXMlidForWorkIssue);
					if(Work_IssueXml != null){
						String wcuRes = soap.uploadWorkToServer(lstWI.get(0).getIssueRaisedby(), "Work_Issues", Work_IssueXml,lastXMlidForWorkIssue);
						if(!wcuRes.equals("Failure")){
							bService.updateXMLSync(wcuRes,lastXMlidForWorkIssue);
						}
					}
				}else{
					if(!resVal.equalsIgnoreCase("Failure")){
						bService.updateXMLSync(resVal,lastXMlidForWorkIssue);
					}
				}
			}
			List<workissues> lstWI = bService.getAllWorkIssue(AppUserDetails.getUsername(),"NULL");
			String workIssuexml = createWorkIssueXMl();
			if(workIssuexml != null){
				noData = true;
				String lastXMlidForAppUserWI = bService.getLastXMLId(AppUserDetails.getUsername(),"Work_Issues","N");
				String wcuRes = soap.uploadWorkToServer(lstWI.get(0).getIssueRaisedby(), "Work_Issues", workIssuexml,lastXMlidForAppUserWI);
				if(!wcuRes.equals("Failure")){
					bService.updateXMLSync(wcuRes,lastXMlidForAppUserWI);
				}
			}

			if(!noData){
				response = "No data to upload";
			}else{
				response = workStatus;
			}
			return response;


		}
		@Override
		protected void onPostExecute(String strResult) {
			this.dialog.dismiss();
			if(strResult.equalsIgnoreCase("No data to upload"))
			{
				Toast.makeText(getApplication(), "No data available to upload", Toast.LENGTH_LONG).show();

			}else if(strResult.equalsIgnoreCase("No Works"))
			{
				Toast.makeText(getApplication(), "No Works", Toast.LENGTH_LONG).show();

			}else
			{
				Toast.makeText(getApplication(), strResult, Toast.LENGTH_LONG).show();
			}
		}


	}

	private void copyDatabaseToSdcard() {
		try {
			File sd = Environment.getExternalStorageDirectory();
			File data = Environment.getDataDirectory();
			//			Toast.makeText(UsermenuActivity.this, "Latest Db Copied to sddcard", Toast.LENGTH_LONG).show();
			if (sd.canWrite()) {
				String currentDBPath = "//data//com.zeal.gov.kar.pwmt.activities//databases//pwmt.db";
				String backupDBPath = "//testingbackup//pwmt.db";
				File currentDB = new File(data, currentDBPath);
				File backupDB = new File(sd, backupDBPath);

				if (currentDB.exists()) {
					FileChannel src = new FileInputStream(currentDB).getChannel();
					FileChannel dst = new FileOutputStream(backupDB).getChannel();
					dst.transferFrom(src, 0, src.size());
					src.close();
					dst.close();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public String createWorkIssueXMl() {
		// TODO Auto-generated method stub
		String sXml = null;
		BaseService baseService = new BaseService(UsermenuActivity.this);
		List<workissues> lst = baseService.getAllWorkIssue(AppUserDetails.getUsername(),"NULL");
		if(lst.size() >0){
			String uuid = UUID.randomUUID().toString().replaceAll("-", "");
			baseService.insertIntoXMLSync(uuid,"Work_Issues",AppUserDetails.getUsername());
			Element root = new Element("NewDataSet");
			Document doc = new Document(root);
			Iterator<workissues> itr = lst.iterator();
			doc.setRootElement(root);
			Element table = new Element("Table");
			table.setAttribute("Name", "Work_Issues");
			while(itr.hasNext()){
				workissues wi = itr.next();
				Element row = new Element("Row");
				row.addContent(new Element("IssueId")
				.setText(String.valueOf(wi.getIssueId())));
				row.addContent(new Element("WorkId")
				.setText(String.valueOf(wi.getWorkId())));
				row.addContent(new Element("IssueTypeId")
				.setText(String.valueOf(wi.getIssueTypeId())));
				row.addContent(new Element("IssueDescription")
				.setText(String.valueOf(wi.getIssueDescription())));
				row.addContent(new Element("IssueRaisedBy")
				.setText(String.valueOf(wi.getIssueRaisedby())));
				row.addContent(new Element("IssueRaisedOn")
				.setText(String.valueOf(wi.getIssueRaisedon())));
				row.addContent(new Element("UpdationId")
				.setText(String.valueOf(wi.getServerId())));
				table.addContent(row);
				baseService.updateWorkIssueWithUUID(wi,uuid);
			}
			doc.getRootElement().addContent(table);
			XMLOutputter xmlOutput = new XMLOutputter();

			// display nice nice
			xmlOutput.setFormat(Format.getPrettyFormat());

			try {
				xmlOutput.output(doc,
						openFileOutput("Work_Issues.xml", Context.MODE_PRIVATE));

				copyXmlToSdcard("Work_Issues");
			} catch (IOException e) {

				e.printStackTrace();

			}
			sXml = xmlOutput.outputString(doc);
			System.out.println("+++++++++" + sXml);
		}

		return sXml;

	}

	public String createWorkIssueXMl(String lastXMlidForWorkIssue) {
		// TODO Auto-generated method stub
		String sXml = null;
		BaseService baseService = new BaseService(UsermenuActivity.this);
		List<workissues> lst = baseService.getAllWorkIssue(lastXMlidForWorkIssue);
		if(lst.size() >0){
			Element root = new Element("NewDataSet");
			Document doc = new Document(root);
			Iterator<workissues> itr = lst.iterator();
			doc.setRootElement(root);
			Element table = new Element("Table");
			table.setAttribute("Name", "Work_Issues");
			while(itr.hasNext()){
				workissues wi = itr.next();
				Element row = new Element("Row");
				row.addContent(new Element("IssueId")
				.setText(String.valueOf(wi.getIssueId())));
				row.addContent(new Element("WorkId")
				.setText(String.valueOf(wi.getWorkId())));
				row.addContent(new Element("IssueTypeId")
				.setText(String.valueOf(wi.getIssueTypeId())));
				row.addContent(new Element("IssueDescription")
				.setText(String.valueOf(wi.getIssueDescription())));
				row.addContent(new Element("IssueRaisedBy")
				.setText(String.valueOf(wi.getIssueRaisedby())));
				row.addContent(new Element("IssueRaisedOn")
				.setText(String.valueOf(wi.getIssueRaisedon())));
				row.addContent(new Element("UpdationId")
				.setText(String.valueOf(wi.getServerId())));
				table.addContent(row);
			}
			doc.getRootElement().addContent(table);
			XMLOutputter xmlOutput = new XMLOutputter();

			// display nice nice
			xmlOutput.setFormat(Format.getPrettyFormat());

			try {
				xmlOutput.output(doc,
						openFileOutput("Work_Issues.xml", Context.MODE_PRIVATE));

				copyXmlToSdcard("Work_Issues");
			} catch (IOException e) {

				e.printStackTrace();

			}
			sXml = xmlOutput.outputString(doc);
			System.out.println("+++++++++" + sXml);
		}

		return sXml;

	}

	public String createWorkCoordinatePhotosxmlXMl(WorkCoordinatePhotos cp,
			String lastXMLId) {
		// TODO Auto-generated method stub

		BaseService baseService = new BaseService(UsermenuActivity.this);
//		List<Work_Component_Updations_Photo> lst = baseService.getAllWork_Component_UpdationPhotos(AppUserDetails.getUsername());
		Element root = new Element("NewDataSet");
		Document doc = new Document(root);
//		Iterator<Work_Component_Updations_Photo> itr = lst.iterator();
		doc.setRootElement(root);
		Element table = new Element("Table");
		table.setAttribute("Name", "Work_CoordinatesPhotos");
		//		while(itr.hasNext()){
		WorkCoordinatePhotos wcus = cp;
		Element row = new Element("Row");
		row.addContent(new Element("Work_CoordinatesId")
//		.setText(String.valueOf(wcus.getWork_CoordinatesId())));
		.setText(String.valueOf(wcus.getServerId())));
		row.addContent(new Element("CoordinateId")
		.setText(String.valueOf(wcus.getCoordinateId())));
		row.addContent(new Element("PhotoId")
		.setText(String.valueOf(wcus.getPhotoId())));
		row.addContent(new Element("PhotoCaption")
		.setText(String.valueOf(wcus.getPhotoCaption())));
		row.addContent(new Element("Latitude")
		.setText(String.valueOf(wcus.getLatitude())));
		row.addContent(new Element("Longitude")
		.setText(String.valueOf(wcus.getLongitude())));
		row.addContent(new Element("PhotoTakenOn")
		.setText(String.valueOf(wcus.getPhotoTakenOn())));
		row.addContent(new Element("PhotoTakenBy")
		.setText(String.valueOf(wcus.getPhotoTakenBy())));
		row.addContent(new Element("PhotoState")
		.setText(String.valueOf(wcus.getWorkState())));
		try{
			File imagePath = new File(wcus.getPhotoPath());
			if (imagePath.exists()) {
				Bitmap bitmap = BitmapFactory.decodeFile(imagePath
						.getAbsolutePath());
				
				
				ByteArrayOutputStream baos = new ByteArrayOutputStream();
				bitmap.compress(Bitmap.CompressFormat.JPEG, 100, baos);
				byte[] b = baos.toByteArray();
				String imageData = Base64.encodeToString(b,
						Base64.DEFAULT);
				row.addContent(new Element("PhotoPath")
				.setText(String.valueOf(imageData)));
			} 
		}catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		table.addContent(row);
		//		}
		doc.getRootElement().addContent(table);
		XMLOutputter xmlOutput = new XMLOutputter();

		// display nice nice
		xmlOutput.setFormat(Format.getPrettyFormat());

		try {
			xmlOutput.output(doc,
					openFileOutput("Work_CoordinatesPhotos.xml", Context.MODE_PRIVATE));

			copyXmlToSdcard("Work_CoordinatesPhotos");
		} catch (IOException e) {

			e.printStackTrace();

		}
		String sXml = xmlOutput.outputString(doc);
		System.out.println("+++++++++" + sXml);

		return sXml;		


	}

	public String createCoordinatePhotosXMl(
			WorkCoordinatePhotos cp) {
		// TODO Auto-generated method stub


		BaseService baseService = new BaseService(UsermenuActivity.this);
//		List<Work_Component_Updations_Photo> lst = baseService.getAllWork_Component_UpdationPhotos(AppUserDetails.getUsername());
		Element root = new Element("NewDataSet");
		Document doc = new Document(root);
//		Iterator<Work_Component_Updations_Photo> itr = lst.iterator();
		doc.setRootElement(root);
		Element table = new Element("Table");
		table.setAttribute("Name", "Work_CoordinatesPhotos");
		//		while(itr.hasNext()){
		WorkCoordinatePhotos wcus = cp;
		Element row = new Element("Row");
		row.addContent(new Element("Work_CoordinatesId")
//		.setText(String.valueOf(wcus.getWork_CoordinatesId())));
		.setText(String.valueOf(wcus.getServerId())));
		row.addContent(new Element("CoordinateId")
		.setText(String.valueOf(wcus.getCoordinateId())));
		row.addContent(new Element("PhotoId")
		.setText(String.valueOf(wcus.getPhotoId())));
		row.addContent(new Element("PhotoCaption")
		.setText(String.valueOf(wcus.getPhotoCaption())));
		row.addContent(new Element("Latitude")
		.setText(String.valueOf(wcus.getLatitude())));
		row.addContent(new Element("Longitude")
		.setText(String.valueOf(wcus.getLongitude())));
		row.addContent(new Element("PhotoTakenOn")
		.setText(String.valueOf(wcus.getPhotoTakenOn())));
		row.addContent(new Element("PhotoTakenBy")
		.setText(String.valueOf(wcus.getPhotoTakenBy())));
		row.addContent(new Element("PhotoState")
		.setText(String.valueOf(wcus.getWorkState())));
		try{
			File imagePath = new File(wcus.getPhotoPath());
			if (imagePath.exists()) {
				Bitmap bitmap = BitmapFactory.decodeFile(imagePath
						.getAbsolutePath());
				ByteArrayOutputStream baos = new ByteArrayOutputStream();
				bitmap.compress(Bitmap.CompressFormat.JPEG, 100, baos);
				byte[] b = baos.toByteArray();
				String imageData = Base64.encodeToString(b,
						Base64.DEFAULT);
				row.addContent(new Element("PhotoPath")
				.setText(String.valueOf(imageData)));
			} 
		}catch (Exception e) {
			// TODO: handle exception
		}
		table.addContent(row);
		//		}
		doc.getRootElement().addContent(table);
		XMLOutputter xmlOutput = new XMLOutputter();

		// display nice nice
		xmlOutput.setFormat(Format.getPrettyFormat());

		try {
			xmlOutput.output(doc,
					openFileOutput("Work_CoordinatesPhotos.xml", Context.MODE_PRIVATE));

			copyXmlToSdcard("Work_CoordinatesPhotos");
		} catch (IOException e) {

			e.printStackTrace();

		}
		String sXml = xmlOutput.outputString(doc);
		System.out.println("+++++++++" + sXml);

		return sXml;		

	}

	public String createWorkCoordinatesXMl() {
		// TODO Auto-generated method stub

		// TODO Auto-generated method stub

		String sXml = null;
		BaseService baseService = new BaseService(UsermenuActivity.this);
		/*int lastXMLid = baseService.getLastXMLId();
		++lastXMLid;*/
		String uuid = UUID.randomUUID().toString().replaceAll("-", "");
		List<Work_Coordinates> lst = baseService.getAllWork_Coordinates(AppUserDetails.getUsername());
		if(lst.size() >0){
			baseService.insertIntoXMLSync(uuid,"Work_Coordinates",AppUserDetails.getUsername());
			Element root = new Element("NewDataSet");
			Document doc = new Document(root);
			Iterator<Work_Coordinates> itr = lst.iterator();
			doc.setRootElement(root);
			Element table = new Element("Table");
			table.setAttribute("Name", "Work_Coordinates");
			while(itr.hasNext()){
				Work_Coordinates wc = itr.next();
				Element row = new Element("Row");
				row.addContent(new Element("Work_CoordinatesId")
				.setText(String.valueOf(wc.getWork_CoordinatesId())));
				row.addContent(new Element("CoordinateId")
				.setText(String.valueOf(wc.getCoordinateId())));
				row.addContent(new Element("WorkId")
				.setText(String.valueOf(wc.getWorkId())));
				row.addContent(new Element("GroupComponentId")
				.setText(String.valueOf(wc.getGroupComponentId())));
				row.addContent(new Element("ComponentGroupId")
				.setText(String.valueOf(wc.getComponentGroupId())));
				row.addContent(new Element("ComponentId")
				.setText(String.valueOf(wc.getComponentId())));
				row.addContent(new Element("SubComponentId")
				.setText(String.valueOf(wc.getSubComponentId())));
				row.addContent(new Element("ChainageId")
				.setText(String.valueOf(wc.getChainageId())));
				row.addContent(new Element("StageId")
				.setText(String.valueOf(wc.getStageId())));
				row.addContent(new Element("Latitude")
				.setText(String.valueOf(wc.getLatitude())));
				row.addContent(new Element("Longitude")
				.setText(String.valueOf(wc.getLongitude())));
				row.addContent(new Element("CreatedOn")
				.setText(String.valueOf(wc.getCreatedOn())));
				row.addContent(new Element("CreatedBy")
				.setText(String.valueOf(wc.getCreatedBy())));
				table.addContent(row);
				baseService.updateWorkCoordinates(wc,uuid);
			}
			doc.getRootElement().addContent(table);
			XMLOutputter xmlOutput = new XMLOutputter();

			// display nice nice
			xmlOutput.setFormat(Format.getPrettyFormat());

			try {
				xmlOutput.output(doc,
						openFileOutput("Work_Coordinates.xml", Context.MODE_PRIVATE));

				copyXmlToSdcard("Work_Coordinates");
			} catch (IOException e) {

				e.printStackTrace();

			}
			sXml = xmlOutput.outputString(doc);
			System.out.println("+++++++++" + sXml);

		}
		return sXml;


	}

	public String createWorkCoordinatesLastXMlID(String lastXMlidForWorkCoor) {
		// TODO Auto-generated method stub

		String sXml = null;
		BaseService baseService = new BaseService(UsermenuActivity.this);
		//		int lastXMLid = baseService.getLastXMLId();
		//		++lastXMLid;
		List<Work_Coordinates> lst = baseService.getAllWork_CoordinatesForXMLID(lastXMlidForWorkCoor);
		if(lst.size() >0){
			//			baseService.insertIntoXMLSync(lastXMLid,"Work_Coordinates",AppUserDetails.getUsername());
			Element root = new Element("NewDataSet");
			Document doc = new Document(root);
			Iterator<Work_Coordinates> itr = lst.iterator();
			doc.setRootElement(root);
			Element table = new Element("Table");
			table.setAttribute("Name", "Work_Coordinates");
			while(itr.hasNext()){
				Work_Coordinates wc = itr.next();
				Element row = new Element("Row");
				row.addContent(new Element("Work_CoordinatesId")
				.setText(String.valueOf(wc.getWork_CoordinatesId())));
				row.addContent(new Element("CoordinateId")
				.setText(String.valueOf(wc.getCoordinateId())));
				row.addContent(new Element("WorkId")
				.setText(String.valueOf(wc.getWorkId())));
				row.addContent(new Element("GroupComponentId")
				.setText(String.valueOf(wc.getGroupComponentId())));
				row.addContent(new Element("ComponentGroupId")
				.setText(String.valueOf(wc.getComponentGroupId())));
				row.addContent(new Element("ComponentId")
				.setText(String.valueOf(wc.getComponentId())));
				row.addContent(new Element("SubComponentId")
				.setText(String.valueOf(wc.getSubComponentId())));
				row.addContent(new Element("ChainageId")
				.setText(String.valueOf(wc.getChainageId())));
				row.addContent(new Element("StageId")
				.setText(String.valueOf(wc.getStageId())));
				row.addContent(new Element("Latitude")
				.setText(String.valueOf(wc.getLatitude())));
				row.addContent(new Element("Longitude")
				.setText(String.valueOf(wc.getLongitude())));
				row.addContent(new Element("CreatedOn")
				.setText(String.valueOf(wc.getCreatedOn())));
				row.addContent(new Element("CreatedBy")
				.setText(String.valueOf(wc.getCreatedBy())));
				table.addContent(row);
			}
			doc.getRootElement().addContent(table);
			XMLOutputter xmlOutput = new XMLOutputter();

			// display nice nice
			xmlOutput.setFormat(Format.getPrettyFormat());

			try {
				xmlOutput.output(doc,
						openFileOutput("Work_Coordinates.xml", Context.MODE_PRIVATE));

				copyXmlToSdcard("Work_Coordinates");
			} catch (IOException e) {

				e.printStackTrace();

			}
			sXml = xmlOutput.outputString(doc);
			System.out.println("+++++++++" + sXml);

		}
		return sXml;

	}

	private class Syncronization extends AsyncTask<String, Void, String>{


		private final ProgressDialog dialog = new ProgressDialog(
				UsermenuActivity.this);

		@Override
		protected void onPreExecute() {
			this.dialog.setMessage("Synchronizing");
			this.dialog.setCancelable(false);
			this.dialog.setCanceledOnTouchOutside(false);
			this.dialog.show();
		}

		@Override
		protected String doInBackground(String... arg0) {
			String response = new String();
			//Database Creation
			SoapProxy soap =  new SoapProxy(UsermenuActivity.this);
			response=soap.getWorksForSynchronization();
			return response;

		}
		@Override
		protected void onPostExecute(String strResult) {
			this.dialog.dismiss();
			if(strResult.equalsIgnoreCase("UserName is not available"))
			{
				Toast.makeText(getApplication(), "UserName is not available", Toast.LENGTH_LONG).show();

			}else if(strResult.equalsIgnoreCase("No Works"))
			{
				Toast.makeText(getApplication(), "No Works", Toast.LENGTH_LONG).show();


			}else if(strResult.equalsIgnoreCase("Failure"))
			{
				Toast.makeText(getApplication(), "Please check your internet connection", Toast.LENGTH_LONG).show();

			}
			else
			{
				parser.getWorksForSynchronization(strResult);
//				Toast.makeText(getApplication(), "Work downloaded", Toast.LENGTH_LONG).show();
				Intent intent=new Intent(UsermenuActivity.this,WorkSynchronizationActivity.class);
				startActivity(intent);
			}
		}

	}
	private String createWorkComponentUpdationXMl(){
		String sXml = null;
		BaseService baseService = new BaseService(UsermenuActivity.this);
		//		int lastXMLid = baseService.getLastXMLId();
		String uuid = UUID.randomUUID().toString().replaceAll("-", "");
		//		++lastXMLid;
		List<Work_Component_UpdateStatus> lst = baseService.getAllWork_Component_UpdationStatus();
		if(lst.size() >0){
			baseService.insertIntoXMLSync(uuid,"Work_Component_UpdateStatus",AppUserDetails.getUsername());
			Element root = new Element("NewDataSet");
			Document doc = new Document(root);
			Iterator<Work_Component_UpdateStatus> itr = lst.iterator();
			doc.setRootElement(root);
			Element table = new Element("Table");
			table.setAttribute("Name", "Work_Component_UpdateStatus");
			while(itr.hasNext()){
				Work_Component_UpdateStatus wcus = itr.next();
				Element row = new Element("Row");
				row.addContent(new Element("FromKM")
				.setText(String.valueOf(wcus.getFromKM())));
				row.addContent(new Element("SubComponentStage")
				.setText(String.valueOf(wcus.getSubComponentStage())));
				row.addContent(new Element("ToKM")
				.setText(String.valueOf(wcus.getToKM())));
				row.addContent(new Element("WorkComponentId")
				.setText(String.valueOf(wcus.getWorkComponentId())));
				row.addContent(new Element("WorkComponentUpdationId")
				.setText(String.valueOf(wcus.getWorkComponentUpdationId())));
				row.addContent(new Element("WorkId")
				.setText(String.valueOf(wcus.getWorkId())));
				row.addContent(new Element("WorkStatusType")
				.setText(String.valueOf(wcus.getWorkStatusType())));
				row.addContent(new Element("ActualEndDate")
				.setText(String.valueOf(wcus.getActualEndDate())));
				row.addContent(new Element("ActualStartDate")
				.setText(String.valueOf(wcus.getActualStartDate())));
				row.addContent(new Element("CreatedBy")
				.setText(String.valueOf(wcus.getCreatedBy())));
				row.addContent(new Element("CreatedOn")
				.setText(String.valueOf(wcus.getCreatedOn())));
				row.addContent(new Element("Lattitude")
				.setText(String.valueOf(wcus.getLattitude())));
				row.addContent(new Element("Longitude")
				.setText(String.valueOf(wcus.getLongitude())));
				row.addContent(new Element("ModifiedBy")
				.setText(String.valueOf(wcus.getModifiedBy())));
				row.addContent(new Element("ModifiedOn")
				.setText(String.valueOf(wcus.getModifiedOn())));
				row.addContent(new Element("WorkStatusAsOn")
				.setText(String.valueOf(wcus.getWorkStatusAsOn())));
				row.addContent(new Element("WorkStatusDescription")
				.setText(String.valueOf(wcus.getWorkStatusDescription())));
				row.addContent(new Element("WorkStatusUpdatedOn")
				.setText(String.valueOf(wcus.getWorkStatusUpdatedOn())));
				table.addContent(row);
				baseService.updateXMLIDForWorkComponentUpdateStatus(String.valueOf(wcus.getWorkComponentUpdationId()),String.valueOf(uuid));
			}
			doc.getRootElement().addContent(table);
			XMLOutputter xmlOutput = new XMLOutputter();

			// display nice nice
			xmlOutput.setFormat(Format.getPrettyFormat());

			try {
				xmlOutput.output(doc,
						openFileOutput("Work_Component_UpdateStatus.xml", Context.MODE_PRIVATE));

				copyXmlToSdcard("Work_Component_UpdateStatus");
			} catch (IOException e) {

				e.printStackTrace();

			}
			sXml = xmlOutput.outputString(doc);
			System.out.println("+++++++++" + sXml);

		}
		return sXml;
	}

	private void copyXmlToSdcard(String name) {
		try {
			File sd = Environment.getExternalStorageDirectory();
			File data = Environment.getDataDirectory();

			if (sd.canWrite()) {
				String currentDBPath = "//data//com.zeal.gov.kar.pwmt.activities//files//"+name+".xml";
				String backupDBPath = ""+name+".xml";
				File currentDB = new File(data, currentDBPath);
				File backupDB = new File(sd, backupDBPath);

				if (currentDB.exists()) {
					FileChannel src = new FileInputStream(currentDB)
					.getChannel();
					FileChannel dst = new FileOutputStream(backupDB)
					.getChannel();
					dst.transferFrom(src, 0, src.size());
					src.close();
					dst.close();
				}
			}
		} catch (Exception e) {

			e.printStackTrace();
		}
	}

	public String createWorkComponentUpdationPhotoXMl(Work_Component_Updations_Photo wcup){

		BaseService baseService = new BaseService(UsermenuActivity.this);
		List<Work_Component_Updations_Photo> lst = baseService.getAllWork_Component_UpdationPhotos(AppUserDetails.getUsername());
		Element root = new Element("NewDataSet");
		Document doc = new Document(root);
		Iterator<Work_Component_Updations_Photo> itr = lst.iterator();
		doc.setRootElement(root);
		Element table = new Element("Table");
		table.setAttribute("Name", "Work_Component_Updations_Photo");
		//		while(itr.hasNext()){
		Work_Component_Updations_Photo wcus = wcup;
		Element row = new Element("Row");
		//			row.addContent(new Element("WorkComponentUpdationId")
		//			.setText(String.valueOf(wcus.getWorkComponentUpdationId())));
		row.addContent(new Element("WorkComponentUpdationId")
		.setText(String.valueOf(wcus.getServerId())));
		row.addContent(new Element("WorkId")
		.setText(String.valueOf(wcus.getWorkId())));
		row.addContent(new Element("CreatedBy")
		.setText(String.valueOf(wcus.getCreatedBy())));
		row.addContent(new Element("CreatedOn")
		.setText(String.valueOf(wcus.getCreatedOn())));
		row.addContent(new Element("Lattitude")
		.setText(String.valueOf(wcus.getLattitude())));
		row.addContent(new Element("Longitude")
		.setText(String.valueOf(wcus.getLongtitude())));
		row.addContent(new Element("ModifiedBy")
		.setText(String.valueOf(wcus.getModifiedBy())));
		row.addContent(new Element("ModifiedOn")
		.setText(String.valueOf(wcus.getModifiedOn())));
		row.addContent(new Element("PhotoId")
		.setText(String.valueOf(wcus.getPhotoId())));
		row.addContent(new Element("PhotoTakenOn")
		.setText(String.valueOf(wcus.getPhotoTakenOn())));
		try{
			File imagePath = new File(wcus.getPhoto());
			if (imagePath.exists()) {
				Bitmap bitmap = BitmapFactory.decodeFile(imagePath
						.getAbsolutePath());
				ByteArrayOutputStream baos = new ByteArrayOutputStream();
				bitmap.compress(Bitmap.CompressFormat.JPEG, 100, baos);
				byte[] b = baos.toByteArray();
				String imageData = Base64.encodeToString(b,
						Base64.DEFAULT);
				row.addContent(new Element("Photo")
				.setText(String.valueOf(imageData)));
			} else{
				return null;
			}
		}catch (Exception e) {
			// TODO: handle exception
		}
		table.addContent(row);
		//		}
		doc.getRootElement().addContent(table);
		XMLOutputter xmlOutput = new XMLOutputter();

		// display nice nice
		xmlOutput.setFormat(Format.getPrettyFormat());

		try {
			xmlOutput.output(doc,
					openFileOutput("Work_Component_Updations_Photo.xml", Context.MODE_PRIVATE));

			copyXmlToSdcard("Work_Component_Updations_Photo");
		} catch (IOException e) {

			e.printStackTrace();

		}
		String sXml = xmlOutput.outputString(doc);
		System.out.println("+++++++++" + sXml);

		return sXml;		
	}

	private String createWorkComponentUpdationXMl(String xmlId){
		String sXml = null;
		BaseService baseService = new BaseService(UsermenuActivity.this);
		List<Work_Component_UpdateStatus> lst = baseService.getAllWork_Component_UpdationStatus(xmlId);
		if(lst.size() > 0){
			Element root = new Element("NewDataSet");
			Document doc = new Document(root);
			Iterator<Work_Component_UpdateStatus> itr = lst.iterator();
			doc.setRootElement(root);
			Element table = new Element("Table");
			table.setAttribute("Name", "Work_Component_UpdateStatus");
			while(itr.hasNext()){
				Work_Component_UpdateStatus wcus = itr.next();
				Element row = new Element("Row");
				row.addContent(new Element("FromKM")
				.setText(String.valueOf(wcus.getFromKM())));
				row.addContent(new Element("SubComponentStage")
				.setText(String.valueOf(wcus.getSubComponentStage())));
				row.addContent(new Element("ToKM")
				.setText(String.valueOf(wcus.getToKM())));
				row.addContent(new Element("WorkComponentId")
				.setText(String.valueOf(wcus.getWorkComponentId())));
				row.addContent(new Element("WorkComponentUpdationId")
				.setText(String.valueOf(wcus.getWorkComponentUpdationId())));
				row.addContent(new Element("WorkId")
				.setText(String.valueOf(wcus.getWorkId())));
				row.addContent(new Element("WorkStatusType")
				.setText(String.valueOf(wcus.getWorkStatusType())));
				row.addContent(new Element("ActualEndDate")
				.setText(String.valueOf(wcus.getActualEndDate())));
				row.addContent(new Element("ActualStartDate")
				.setText(String.valueOf(wcus.getActualStartDate())));
				row.addContent(new Element("CreatedBy")
				.setText(String.valueOf(wcus.getCreatedBy())));
				row.addContent(new Element("CreatedOn")
				.setText(String.valueOf(wcus.getCreatedOn())));
				row.addContent(new Element("Lattitude")
				.setText(String.valueOf(wcus.getLattitude())));
				row.addContent(new Element("Longitude")
				.setText(String.valueOf(wcus.getLongitude())));
				row.addContent(new Element("ModifiedBy")
				.setText(String.valueOf(wcus.getModifiedBy())));
				row.addContent(new Element("ModifiedOn")
				.setText(String.valueOf(wcus.getModifiedOn())));
				row.addContent(new Element("WorkStatusAsOn")
				.setText(String.valueOf(wcus.getWorkStatusAsOn())));
				row.addContent(new Element("WorkStatusDescription")
				.setText(String.valueOf(wcus.getWorkStatusDescription())));
				row.addContent(new Element("WorkStatusUpdatedOn")
				.setText(String.valueOf(wcus.getWorkStatusUpdatedOn())));
				table.addContent(row);
			}
			doc.getRootElement().addContent(table);
			XMLOutputter xmlOutput = new XMLOutputter();

			// display nice nice
			xmlOutput.setFormat(Format.getPrettyFormat());

			try {
				xmlOutput.output(doc,
						openFileOutput("Work_Component_UpdateStatus.xml", Context.MODE_PRIVATE));

				copyXmlToSdcard("Work_Component_UpdateStatus");
			} catch (IOException e) {

				e.printStackTrace();

			}
			sXml = xmlOutput.outputString(doc);
			System.out.println("+++++++++" + sXml);
		}
		return sXml;
	}
	
	public String createWorkComponentUpdationPhotoXMl(Work_Component_Updations_Photo wcup,String xmlId){

		BaseService baseService = new BaseService(UsermenuActivity.this);
		List<Work_Component_Updations_Photo> lst = baseService.getAllWork_Component_UpdationPhotos(AppUserDetails.getUsername());
		Element root = new Element("NewDataSet");
		Document doc = new Document(root);
		Iterator<Work_Component_Updations_Photo> itr = lst.iterator();
		doc.setRootElement(root);
		Element table = new Element("Table");
		table.setAttribute("Name", "Work_Component_Updations_Photo");
		//		while(itr.hasNext()){
		Work_Component_Updations_Photo wcus = wcup;
		Element row = new Element("Row");
		/*row.addContent(new Element("WorkComponentUpdationId")
			.setText(String.valueOf(wcus.getWorkComponentUpdationId())));*/
		row.addContent(new Element("WorkComponentUpdationId")
		.setText(String.valueOf(wcus.getServerId())));
		row.addContent(new Element("WorkId")
		.setText(String.valueOf(wcus.getWorkId())));
		row.addContent(new Element("CreatedBy")
		.setText(String.valueOf(wcus.getCreatedBy())));
		row.addContent(new Element("CreatedOn")
		.setText(String.valueOf(wcus.getCreatedOn())));
		row.addContent(new Element("Lattitude")
		.setText(String.valueOf(wcus.getLattitude())));
		row.addContent(new Element("Longitude")
		.setText(String.valueOf(wcus.getLongtitude())));
		row.addContent(new Element("ModifiedBy")
		.setText(String.valueOf(wcus.getModifiedBy())));
		row.addContent(new Element("ModifiedOn")
		.setText(String.valueOf(wcus.getModifiedOn())));
		row.addContent(new Element("PhotoId")
		.setText(String.valueOf(wcus.getPhotoId())));
		row.addContent(new Element("PhotoTakenOn")
		.setText(String.valueOf(wcus.getPhotoTakenOn())));
		try{
			File imagePath = new File(wcus.getPhoto());
			if (imagePath.exists()) {
				Bitmap bitmap = BitmapFactory.decodeFile(imagePath
						.getAbsolutePath());
				
				ByteArrayOutputStream baos = new ByteArrayOutputStream();
				bitmap.compress(Bitmap.CompressFormat.JPEG, 100, baos);
				byte[] b = baos.toByteArray();
				String imageData = Base64.encodeToString(b,
						Base64.DEFAULT);
				row.addContent(new Element("Photo")
				.setText(String.valueOf(imageData)));
			} 
		}catch (Exception e) {
			// TODO: handle exception
		}

		table.addContent(row);
		//		}
		doc.getRootElement().addContent(table);
		XMLOutputter xmlOutput = new XMLOutputter();

		// display nice nice
		xmlOutput.setFormat(Format.getPrettyFormat());

		try {
			xmlOutput.output(doc,
					openFileOutput("Work_Component_Updations_Photo.xml", Context.MODE_PRIVATE));

			copyXmlToSdcard("Work_Component_Updations_Photo");
		} catch (IOException e) {

			e.printStackTrace();

		}
		String sXml = xmlOutput.outputString(doc);
		System.out.println("+++++++++" + sXml);

		return sXml;		
	}

}
